local actions = {}
rooms = require "rooms"
local tile_clicked = 0
local tile_overed = 0
actions.door_overed = {direction = 0, index = 0}
actions.celldoor_overed = 0
actions.mouselog = ""
actions.over = ""
actions.current_action = ""
actions.current_mode = "default"
actions.turn = ""
actions.debug = ""
actions.dead_npcs = {}
actions.attack_malus = 0
actions.charge_threshold = 3
actions.skip = false
actions.current_door_cursor = interface.cursor_key
actions.current_door_action = "opencell"
actions.current_chest_cursor = interface.cursor_key
actions.current_chest_action = "openchest"
actions.tile_framed = 0

function actions.draw()
end

function actions.update()
	-- turns
	if tiles.next_turn then
		if tiles.next_turn == tiles.prev_turn then
			tiles.next_turn = ""
		else
			tiles.prev_turn = tiles.next_turn
			helper.log("Nouveau tour:"..tostring(tiles.next_turn))
			helper.log("NPC Attack :"..tostring(tiles.npc_attack))
		end
	end
	-- wait button
	if tiles.turn == "player" then
		interface.buttons.wait.state = "default"
	else
		interface.buttons.wait.state = "active"
	end
	if tiles.next_turn == "exit" then
		actions.exit_room(actions.next_room_direction)
	elseif tiles.next_turn == "npcs" then
		tiles.turn = "npcs"
		tiles.player_step = 0
		player.last_movement = {}
		interface.setCursor(interface.cursor_wait)
		tiles.next_turn = false
		actions.tile_clicked = 0
		actions.attack_malus = 0
		actions.move_npcs()
	elseif tiles.next_turn == "player" then
		tiles.turn = "player"
		interface.setCursor(interface.cursor_default)
		tiles.next_turn = false
		actions.newturn(tiles.player,true)	
	elseif tiles.next_turn == "player_enter" then
		tiles.turn = "player"
		interface.setCursor(interface.cursor_default)
		tiles.next_turn = false
		actions.skip = true
		actions.newturn(tiles.player,false)
	elseif tiles.next_turn == "player_teleport" then
		tiles.turn = "pause"
		interface.setCursor(interface.cursor_default)
		tiles.next_turn = false
	elseif tiles.next_turn == "opencell" then
		actions.open_cell("open")
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "pickcell" then
		actions.open_cell("pick")
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "magic_open" then
		actions.open_cell("magic")
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "pick" then
		actions.pick()
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "openchest" then
		actions.pick()
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "pickchest" then
		actions.pick("pick")
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "deactivatetrap" then
		actions.deactivate_trap()
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "attack" then
		actions.attack()
	elseif tiles.next_turn == "magic_attack" then
		actions.magic_attack(false)
		tiles.next_turn = "npcs"	
	elseif tiles.next_turn == "scroll_attack" then
		actions.magic_attack(true)
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "teleport" then
		actions.teleport()
	elseif tiles.next_turn == "teleport_failed" then
		actions.teleport_failed()
		tiles.next_turn = "npcs"
	elseif tiles.next_turn == "victory" then
		actions.exit_level()
		tiles.next_turn = ""
	elseif tiles.npc_attack then
		actions.attack(tiles.npc_attack)
		tiles.npc_attack = nil
	end
	-- kill npcs
	for npc_index,npc in pairs(actions.dead_npcs) do
		if npc.alpha > 0 then
			npc.alpha = npc.alpha - 0.02
			if tiles.sprites[npc.position] and #tiles.sprites[npc.position] and npc.layer then
				print ("Position : "..tostring(npc.position))
				print ("Layer : "..tostring(npc.layer))
				if tiles.sprites[npc.position][npc.layer].alpha ~= nil then
					tiles.sprites[npc.position][npc.layer].alpha = npc.alpha
				end
			end
		else
			if npc.position ~= nil and tiles.sprites[npc.position] ~= nil then
				tiles.sprites[npc.position][npc.layer] = nil
			end
			actions.dead_npcs[npc_index] = nil
			actions.get_booty(npc)
		end
	end
end

function love.resize(w, h)
	tiles.screen_init()
end

function love.keyreleased( key, code )
	helper.logkey(key)
   if helper.console then
   	key = string.gsub(key, "kp", "")
   	if key == "escape" then
			helper.close_console()
		elseif key == 'return' or key=="enter" then
			helper.run_console()
		elseif key == 'space' then
			helper.command = helper.command.." "
		elseif key == 'backspace' then
			helper.command = helper.command:sub(1, -2)
		else
   		helper.command = helper.command..key
   	end
   else
	   helper.log("Key : "..key)
	   if key == 'return' then
	   	if helper.mode == "dev" then
	   		if not helper.console then
	   			helper.start_console()
	   		end
	   	end	
	   end 
	   if key == "escape" then
	   	if menu.escapable then
				menu.showmenu()
				interface.buttons.menu.prevstate = interface.buttons.menu.state
			end
		end
	   if key == 'space' then
	   		if tiles.turn == "player" then
	   			actions.skip = true
	   			tiles.next_turn = "npcs"
	   		end
	   end   
	   if key == 'x' then
	    	if tiles.debug then
	    		tiles.debug = false
	    	else
	    		tiles.debug = true
	    	end
	   end   
	   if key == 's' then
	    	if tiles.show_sprites then
	    		tiles.show_sprites = false
	    	else
	    		-- tiles.show_sprites = true
	    	end
	   end  
	   if key == 'f' then
	   		if love.window.getFullscreen() then
	   			love.window.setFullscreen(false)
	   		else
	   			love.window.setFullscreen(true)   
	   		end			
	   end     
	   if key == 'd' then
	   	if helper.mode == "dev" then
	   		helper.debug = ""	
	   		helper.mode = "prod"
	   	else
	   		-- helper.mode ="dev"
	   	end	
	   end 
	   if key == 'c' then
	   		helper.debug = ""		
	   end 
	   if key == 'e' then
	   	-- helper.log("Exits : "..rooms.count_level_exits())
	   end
	   if key == 'o' then
	   	--[[
	   		helper.log("---- Objets de la pièce ----")
				for k,v in pairs(tiles.current_room.items) do
					helper.log(k.." - "..tostring(v))
					if type(v)=='table' then
						for a,b in pairs(v) do
							helper.log(a.." - "..tostring(b))									
						end
					end
				end
				helper.log("--------------------")		
				]]
	   end   
	   if key == 's' then
	   	--[[
	   		helper.log("---- Sprites de la pièce ----")
				for k,v in pairs(tiles.sprites) do
					helper.log("position : "..k)
					for a,b in pairs(v) do
						helper.log("layer : "..tostring(v))	
						for x,y in pairs(b) do
							helper.log(x.." - "..tostring(y))
							if type(y)=='table' then
								for d,e in pairs(y) do
									helper.log(d.." - "..tostring(e))									
								end
							end								
						end							
					end
					helper.log("---")
				end
				helper.log("--------------------")	
			]]
	   end
	   if key == 'm' then
			map.showmap()
	   end
	   if key == 'i' then
			sheet.showsheet()
	   end
	   if key == 'kp1' or key == 'kp2' or key == 'kp3' or key == 'kp4' or key == 'kp6' or key == 'kp7' or key == 'kp8' or key == 'kp9' then
	   	local keys = {'kp1','kp2','kp3','kp4','kp6','kp7','kp8','kp9'}
	   	local directions = {'W','SW','S','NW','SE','N','NE','E'}
	   	local key_index = helper.index_of(keys, key)
	   	tiles.player_direction = directions[key_index]
	   	tiles.update_sprite(tiles.current_player_position,rooms.level.special_items.player.tile,tiles.image_player,rooms.level.special_items.player.layer,true,nil,tiles.player_direction)
	   	tiles.set_luminosity(tiles.current_room.lights,1,5)
	   end
	   if key == 'kp+' then
	   	if tonumber(config.music_volume) < 1 then
	   		config.music_volume = tonumber(config.music_volume) + 0.1
	   		sounds.update_music_volume()
	   	end
	   end
	   if key == 'kp-' then
	   	if tonumber(config.music_volume) > 0 then
	   		config.music_volume = tonumber(config.music_volume) - 0.1
	   		sounds.update_music_volume()
	   	end
	   end
	end
end

function love.wheelmoved(x, y)
    if y > 0 then
        local directions = {'W','SW','S','SE','E','NE','N','NW'}
   	  local direction_index = helper.index_of(directions, tiles.player_direction)
   	  if direction_index == 8 then
   	  		direction_index = 1
   	  	else
   	  		direction_index = direction_index + 1   	  
   	  end
   	  tiles.player_direction = directions[direction_index]
   	  tiles.update_sprite(tiles.current_player_position,rooms.level.special_items.player.tile,tiles.image_player,rooms.level.special_items.player.layer,true,nil,tiles.player_direction)
   	  tiles.set_luminosity(tiles.current_room.lights,1,5)
    elseif y < 0 then
        local directions = {'W','SW','S','SE','E','NE','N','NW'}
   	  local direction_index = helper.index_of(directions, tiles.player_direction)
   	  if direction_index == 1 then
   	  		direction_index = 8
   	  	else
   	  		direction_index = direction_index - 1   	  
   	  end
   	  tiles.player_direction = directions[direction_index]
   	  tiles.update_sprite(tiles.current_player_position,rooms.level.special_items.player.tile,tiles.image_player,rooms.level.special_items.player.layer,true,nil,tiles.player_direction)
   	  tiles.set_luminosity(tiles.current_room.lights,1,5)
    end
end


function love.mousemoved(x, y, button)
   -- menu
	if menu.visible then
      local start_x = love.graphics.getWidth()/2 -menu.current_params.width/2
      local start_y =  love.graphics.getHeight()/2 - menu.current_params.height/2
      local rel_x = x - start_x
      local rel_y = y - start_y
      interface.setCursor(interface.cursor_default)
      for k,item in ipairs(menu.current_items) do 
         if item.action.task and rel_x>item.x and rel_x<item.x+item.width and rel_y>item.y and rel_y<item.y+item.height then
            menu.drawmenu()
            item.hover = true
            interface.setCursor(interface.cursor_hand)
         else
            item.hover = false
         end
      end
   else
   	-- Player actions
			current_cursor = interface["cursor_"..actions.current_mode]
			actions.current_action = ""
			actions.tile_overed = 0
			actions.tile_framed = 0
			tiles.celldoor_overed = 0
			actions.celldoor_overed = 0
			tiles.tile_overed_color = interface.tile_color_default
		-- Cards
		if #interface.cards>0 then
			local cards_hovered = 0
			for card_index,card in ipairs(interface.cards) do 
				if card.sprite and card.sprite.x and card.sprite.y and card.sprite.width and card.sprite.height then
					if not card.selected and x>card.sprite.x and x<card.sprite.x+card.sprite.width and y>card.sprite.y and y<card.sprite.y+card.sprite.height then
						cards_hovered = cards_hovered + 1
						current_cursor = interface.cursor_hand
						card.index = card_index
						if card.type == "skill" then
							local button_height = card.sprite.height
							interface.square_button = {
								font = interface.font_button,
								x = card.sprite.x, 
								y = card.sprite.y, 
								width = card.sprite.width, 
								height = button_height,
								text = lang.card_skill_select,
								action = "select",
								target = card,
								select_y = card.select_y
							}
						else
							local button_height
							local card_actions
							local card_texts
							if card.type == "spell" then
								card_actions = {"cast","cancel",""}
								card_texts = {lang.spell_cast,lang.spell_cancel,""}
								button_height = card.sprite.height/2
							elseif card.type == "scroll" then
								card_actions = {"equip","drop","cast"}
								card_texts = {lang.card_equip,lang.card_drop,lang.spell_cast}
								button_height = card.sprite.height/3
							else
								card_actions = {"equip","drop","use"}
								card_texts = {lang.card_equip,lang.card_drop,lang.card_use}
								button_height = card.sprite.height/3
								if card.uses<1 then
									 button_height = card.sprite.height/2
								end
							end
							if y<card.sprite.y+button_height then
								interface.square_button = {
									font = interface.font_button,
									x = card.sprite.x, 
									y = card.sprite.y, 
									width = card.sprite.width, 
									height = button_height,
									text = card_texts[1],
									action = card_actions[1],
									target = card
								}
							elseif y>card.sprite.y+card.sprite.height-button_height then
								interface.square_button = {
									font = interface.font_button,
									x = card.sprite.x, 
									y = card.sprite.y+card.sprite.height-button_height,
									width = card.sprite.width, 
									height = button_height,
									text = card_texts[2],
									action = card_actions[2],
									target = card
								}
							else
								interface.square_button = {
									font = interface.font_button,
									x = card.sprite.x, 
									y = card.sprite.y+button_height, 
									width = card.sprite.width, 
									height = button_height,
									text = card_texts[3],					
									action = card_actions[3],
									target = card
								}
							end	
						end
					end
				else
					helper.debug = ""
					helper.log("################")
					helper.log("card = "..tostring(card))
					helper.log("card.sprite = "..tostring(card.sprite))
					helper.log("icard.sprite.x = "..tostring(card.sprite.x))
					helper.log("icard.sprite.y = "..tostring(card.sprite.y))
					helper.log("icard.sprite.width = "..tostring(card.sprite.width))
					helper.log("icard.sprite.height = "..tostring(card.sprite.height))
				end	
			end
			if cards_hovered == 0 then
				interface.square_button = nil
				current_cursor = interface.cursor_default
			end	
			if interface.skills_interface.confirm_button.visible then
				local button = interface.skills_interface.confirm_button
				if (x>button.x and x<button.x+button.width) and (y>button.y and y<button.y+button.height) then
					current_cursor = interface.cursor_hand
					button.hover = true
				else
					button.hover = false
				end
			end
			interface.setCursor(current_cursor)
		else
			-- Player actions
			for i = #tiles.background_tiles, 1, -1 do
				local tile_index = i
				local tile = tiles.background_tiles[i]
				if tile_index <= tiles.rows*tiles.columns then
					local over = isOvered(tile,x,y)
					if over then
						if actions.current_mode == "default" then
							if tile.luminosity>tiles.min_light then
								if tile_index == actions.tile_clicked then
									current_cursor = interface.cursor_move
								end
								actions.tile_overed = tile_index	
								tiles.tile_overed_color = interface.tile_color_default
								for _, item in pairs( tiles.current_room.items ) do 
									if item.position == tile_index then
										if item.action then								
											actions.current_action = item.action
											if actions.current_action == "teleport" then
												current_cursor = interface.cursor_exit
											elseif actions.current_action == "victory" then
												current_cursor = interface.cursor_out
											elseif item.type == "Barrel" and item.state == nil then
												current_cursor = interface.cursor_attack
											elseif item.type == "Chest" and item.state == nil then
												current_cursor = actions.current_chest_cursor
												actions.current_action = actions.current_chest_action
											else
												current_cursor = interface.cursor_pick
											end
										end
										if item.type == "Trap" and item.state == nil then
											-- trap detection
											if helper.in_array(player.skills.abilities,"TRAPDETECTION") then
												tiles.tile_overed_color = interface.tile_color_danger
											end
											-- trap deactivation
											if helper.in_array(player.skills.abilities,"TRAPDEACTIVATION") then
												current_cursor = interface.cursor_mech
												actions.current_action = "deactivatetrap"
											end
										end
									end
								end				
								for _, item in pairs( tiles.current_room.npcs ) do 
									if item.position == tile_index then
										current_cursor = interface.cursor_attack
										actions.current_action = "attack"
									end
								end
							else
								-- Cell door
								for _, cell in ipairs( tiles.current_room.cells ) do
									if rooms.player_in_cell(cell) then
										celldoor_in = cell.door.cell_out
										celldoor_out = cell.door.cell_in
									else
										celldoor_in = cell.door.cell_in
										celldoor_out = cell.door.cell_out
									end
									if tile_index == celldoor_in and not cell.opened then
										celldoor_tile = tiles.get_tile(celldoor_out)
										if celldoor_tile.luminosity>tiles.min_light then
											actions.tile_overed = celldoor_out
											actions.celldoor_overed = celldoor_in
											tiles.celldoor_overed = cell.position
											current_cursor = actions.current_door_cursor										
											actions.current_action = actions.current_door_action
										end
									end
								end
							end
						elseif actions.current_mode=="teleport" then
							actions.current_action = "teleport"
							if tile.luminosity>tiles.min_light then
								actions.tile_overed = tile_index	
								tiles.tile_overed_color = interface.tile_color_default
								for _, item in pairs( tiles.current_room.items ) do 
									if item.position == tile_index then
										if item.solid == true then
											current_cursor = interface.cursor_busy
											actions.current_action = "disabled"
										end
										if item.type == "Trap" then
											-- trap detection
											if helper.in_array(player.skills.abilities,"TRAPDETECTION") then
												tiles.tile_overed_color = interface.tile_color_danger
											end
										end
									end
								end				
								for _, item in pairs( tiles.current_room.npcs ) do 
									if item.position == tile_index then
										current_cursor = interface.cursor_busy
										actions.current_action = "disabled"
									end
								end
							else
								actions.tile_framed = tile_index
								for _, item in pairs( tiles.current_room.items ) do 
									if item.position == tile_index and item.solid == true then
											actions.current_action = "teleport_failed"
									end
								end
								for _, item in pairs( tiles.current_room.npcs ) do 
									if item.position == tile_index then
										actions.current_action = "teleport_failed"
									end
								end
							end
						elseif actions.current_mode=="bolt" or actions.current_mode=="bolt_scroll" then
							actions.current_action = "disabled"
							current_cursor = interface.cursor_busy
							if tile.luminosity>tiles.min_light then
								actions.tile_overed = tile_index	
								tiles.tile_overed_color = interface.tile_color_default
								-- Annulé pour l'instant : problème récupération pièces ou clés
								--[[
								for _, item in pairs( tiles.current_room.items ) do 
									if item.position == tile_index then
										if item.type == "Barrel" then
											current_cursor = interface.cursor_attack
											actions.current_action = "magic_attack"
										end
									end
								end	
								]]			
								for _, item in pairs( tiles.current_room.npcs ) do 
									if item.position == tile_index then		
										current_cursor = interface.cursor_bolt	
										if actions.current_mode=="bolt" then							
											actions.current_action = "magic_attack"
										elseif actions.current_mode=="bolt_scroll" then							
											actions.current_action = "scroll_attack"
										end
									end
								end
							end
						elseif actions.current_mode=="magicopen" then
							actions.current_action = "disabled"
							current_cursor = interface.cursor_busy
							for _, cell in ipairs( tiles.current_room.cells ) do
								if rooms.player_in_cell(cell) then
									celldoor_in = cell.door.cell_out
									celldoor_out = cell.door.cell_in
								else
									celldoor_in = cell.door.cell_in
									celldoor_out = cell.door.cell_out
								end
								if tile_index == celldoor_in and not cell.opened then
									celldoor_tile = tiles.get_tile(celldoor_out)
									if celldoor_tile.luminosity>tiles.min_light then
										actions.tile_overed = celldoor_out
										actions.celldoor_overed = celldoor_in
										tiles.celldoor_overed = cell.position
										current_cursor = interface.cursor_magicopen										
										actions.current_action = "magic_open"
									end
								end
							end
						end
					end
				end
			end
			for tile_index, tile in ipairs(tiles.doors.N) do
				local over = isOvered(tile,x,y)
				if over then
					if tile.luminosity>tiles.min_light then
						current_cursor = interface.cursor_exit
						if tiles.current_room.exit and rooms.exit.wall == "N" then
							current_cursor = interface.cursor_out
						end
						actions.door_overed.index = tile_index
						actions.door_overed.direction = "N"
						actions.tile_overed = 0
					end
				elseif actions.door_overed.direction == "N" then
					actions.door_overed.index = 0
					actions.door_overed.direction = 0
				end
			end
			for tile_index, tile in ipairs(tiles.doors.E) do
				local over = isOvered(tile,x,y)
				if over then
					if tile.luminosity>tiles.min_light then
						current_cursor = interface.cursor_exit
						if tiles.current_room.exit and rooms.exit.wall == "E" then
							current_cursor = interface.cursor_out
						end
						actions.door_overed.index = tile_index
						actions.door_overed.direction = "E"
						actions.tile_overed = 0
					end
				elseif actions.door_overed.direction == "E" then
					actions.door_overed.index = 0
					actions.door_overed.direction = 0
				end
			end

			for tile_index, tile in ipairs(tiles.doors.S) do
				local over = isOvered(tile,x,y)
				if over then
					if tile.luminosity>tiles.min_light then
						current_cursor = interface.cursor_exit
						if tiles.current_room.exit and rooms.exit.wall == "S" then
							current_cursor = interface.cursor_out
						end
						actions.door_overed.index = tile_index
						actions.door_overed.direction = "S"
						actions.tile_overed = 0
					end
				elseif actions.door_overed.direction == "S" then
					actions.door_overed.index = 0
					actions.door_overed.direction = 0
				end
			end	
			for tile_index, tile in ipairs(tiles.doors.W) do
				local over = isOvered(tile,x,y)
				if over then
					if tile.luminosity>tiles.min_light then
						current_cursor = interface.cursor_exit
						if tiles.current_room.exit and rooms.exit.wall == "W" then
							current_cursor = interface.cursor_out
						end
						actions.door_overed.index = tile_index
						actions.door_overed.direction = "W"
						actions.tile_overed = 0
					end
				elseif actions.door_overed.direction == "W" then
					actions.door_overed.index = 0
					actions.door_overed.direction = 0
				end
			end
			if tiles.turn == "npcs" then
				current_cursor = interface.cursor_wait
			end		
			-- interface cards
			local icard_hover = false
			for card_index,icard in pairs(tiles.player.items) do
				if icard and icard.sprite and icard.sprite.x and icard.sprite.y and icard.sprite.width and icard.sprite.height then
					if x>icard.sprite.x and x<icard.sprite.x+icard.sprite.width and y>icard.sprite.y and y<icard.sprite.y+icard.sprite.height then
						interface.square_button = {
							font = interface.font_log,
							x = icard.sprite.x, 
							y = icard.sprite.y, 
							width = icard.sprite.width, 
							height = icard.sprite.height,
							text = lang.card_zoom,
							action = "zoom",
							target = icard
						}
						current_cursor = interface.cursor_hand
						icard_hover = true
					end
				end
			end
			-- interface spells cards
			for card_index,icard in pairs(player.spells) do
				if icard and icard.sprite and icard.enabled and icard.sprite.x and icard.sprite.y and icard.sprite.width and icard.sprite.height then
					if x>icard.sprite.x and x<icard.sprite.x+icard.sprite.width and y>icard.sprite.y and y<icard.sprite.y+icard.sprite.height then
						interface.square_button = {
							font = interface.font_log,
							x = icard.sprite.x, 
							y = icard.sprite.y, 
							width = icard.sprite.width, 
							height = icard.sprite.height,
							text = lang.card_zoom,
							action = "zoom",
							target = icard
						}
						current_cursor = interface.cursor_hand
						icard_hover = true
					end
				end
			end
			if not icard_hover then
				interface.square_button = nil
			end
			interface.setCursor(current_cursor)
		end
	end
	-- interface buttons
	for button_name,butt in pairs(interface.buttons) do 
      if x>butt.x and x<butt.x+butt.width and y>butt.y and y<butt.y+butt.height then
      	if butt.state == "default" then
      		butt.prevstate = butt.state
      	end
         butt.state = "hover"
         interface.setCursor(interface.cursor_hand)
      else
         butt.state = butt.prevstate
      end
   end
end

function love.mousepressed(x, y, button)
	-- Left button
	if button == 1 then
		helper.log(tiles.tile_overed)
		if menu.visible then
	      local start_x = love.graphics.getWidth()/2 -menu.current_params.width/2
	      local start_y =  love.graphics.getHeight()/2 - menu.current_params.height/2
	      local rel_x = x - start_x
	      local rel_y = y - start_y 
	      for k,item in ipairs(menu.current_items) do 
	      	if item.action then
	      		if item.action.task == "setting" then      			
				      for _,button in ipairs(menu.setting_buttons) do 
		               if rel_x>button.x and rel_x<button.x+item.width and rel_y>button.y+button.height/2 and rel_y<button.y+button.height+button.height/2 then
		                  menu.action(item.action,button.prop,button.value)
		                  menu.drawmenu()
		               end
		            end
		         elseif rel_x>item.x and rel_x<item.x+item.width and rel_y>item.y and rel_y<item.y+item.height then
		            menu.action(item.action)
		         end
	         end
	      end  
	   else
			actions.mouselog = ""
			tiles.next_action = ""
			actions.next_room_direction = ""						
			if tiles.turn == "player" then
				-- Cards	
				local button = interface.square_button
				if button then
					if (x>button.x and x<button.x+button.width) and (y>button.y and y<button.y+button.height) then
						local card = button.target
						if button.action == "select" then
							card.selected = true
							card.shadowed = false
							for card_index,card2 in ipairs(interface.cards) do 
								if card_index ~= card.index then
									card2.shadowed = true
									card2.selected = false
								end
							end
							interface.skills_interface.confirm_button.visible = true
							interface.skills_interface.card_selected = card
							local abilities = skills.get_abilities(card)
							interface.skills_interface.access_text = ""
							for i, var in pairs(abilities) do
								abilities[i] = lang["skill_"..var]
							end
							if #abilities>0 then
								interface.skills_interface.access_text = lang.interface_skills_text_access..helper.serialize(abilities,", ")
							end
							local spells= skills.get_spells(card)
							for i, var in pairs(spells) do
								spells[i] = lang["spell_"..var]
							end
							if #spells>0 then
								if #abilities > 0 then
									interface.skills_interface.access_text = interface.skills_interface.access_text.."\r\n"
								end
								interface.skills_interface.access_text = interface.skills_interface.access_text..lang.interface_skills_text_access_spells..helper.serialize(spells,", ")
							end
						elseif button.action == "equip" then
							if interface.can_insert(card) then
								actions.equip_card(card)
								interface.sort_cards()
							else
								interface.show_icon(interface.icon_tiles.fail)
								sounds.fail:play() 
							end
						elseif button.action == "cancel" then
								table.remove(interface.cards,card.index)
						elseif button.action=="drop" then
								local purse
								local purse_exists = false
								if not card.purse_index then
									card.purse_index = tiles.current_player_position
								end
								for item_index,item in pairs(tiles.current_room.items) do	
									if item.position == card.purse_index then
										if item.booty then
											purse_exists = true
											table.insert(item.booty,card)
											item.action = "pick"
										end
									end
								end
								if not purse_exists then
									purse = {
										type="Purse",
								      tile=rooms.level.special_items.purse.tile,
								      solid=rooms.level.special_items.purse.solid,
								      layer=rooms.level.special_items.purse.layer,
								      booty={},
								      action=rooms.level.special_items.purse.action
									}
									purse.position = card.purse_index
									table.insert(purse.booty,card)
									if not tiles.current_room.items then
										tiles.current_room.items = {}
									end
									table.insert(tiles.current_room.items,purse)
									tiles.change_tile(purse.position,purse.tile,tiles.image_items,purse.layer,purse.solid)
								end
								table.remove(interface.cards,card.index)
								effects.update_item_modifiers()								
								if card.type == 'torch' then
									tiles.set_luminosity(tiles.current_room.lights,1,5)
								end
						elseif button.action=="use" then
								if card.type == "potion" then
									local amount = effects.drink_potion(card)
									if amount <=0 then
										table.remove(interface.cards,card.index)
									end
								elseif card.type == "orb" then
									local amount = effects.use_orb(card)
								end
								effects.update_item_modifiers()
						elseif button.action=="cast" then
							local interface_card = {
								type= card.type,
							   subtype= card.subtype,
							   name= card.name,
							   desc= card.desc,
							   tile= card.tile,
							   value= card.value,
							   uses= card.uses,
								sprite = interface.new_sprite(interface.inventory_card_width, interface.inventory_card_height, card.tile, interface.image_card_items_inventory, interface.inventory_card_tileset_width, interface.inventory_card_tileset_height)
							}					
							if card.type == 'spell' then
								local modifier = card.effect
								interface_card.effect = {
							   	type=modifier.type,
							   	property=modifier.property,
							   	amount=modifier.amount,
							   	max=modifier.max,
							   	ambi=modifier.ambi,
							   	duration=modifier.duration,
							   	cost=modifier.cost,
							   	action=modifier.action
							   }
							else
								local modifier = card.modifier
								interface_card.modifier = {
							   	type=modifier.type,
							   	property=modifier.property,
							   	amount=modifier.amount,
							   	max=modifier.max,
							   	ambi=modifier.ambi,
							   	duration=modifier.duration,
							   	cost=modifier.cost,
							   	action=modifier.action
							   }
								interface.pending_inventory_card = interface_card
							end				
							local scroll = (card.type == 'scroll')
							effects.cast_spell(card,scroll)
							table.remove(interface.cards,card.index)
							if scroll then
								local tmp_cards = {}
								for _,card in ipairs(interface.cards) do
									table.insert(tmp_cards,card)
								end
								for _,card in ipairs(tmp_cards) do
									actions.equip_card(card)
									helper.removeByIndex(interface.cards, card.index)
								end
								interface.sort_cards()
							end
						elseif button.action=="zoom" then	
								helper.log("ZOOM")							
								local card = button.target
								if card.type == "spell" then
									helper.log("SPELL")
									interface.add_card(card,interface.image_card_spells)
								else
									helper.log("ITEM")
									local slot = interface.inventory_slots[card.slot_index]
									local tmp_cards = {}									
									for _,card_index in ipairs(slot.cards) do
										local card_displayed = tiles.player.items[card_index]
										helper.log("Slot index "..card_index.." / Card index "..card_displayed.index)
										if card_displayed then
											helper.log("Carte affichée : "..card_index)
											interface.add_card(card_displayed,interface.image_card_items)
											table.insert(tmp_cards,card_index)
										end
									end
									for _,card_index in ipairs(tmp_cards) do
										helper.removeByIndex(tiles.player.items,card_index)
									end
									interface.sort_cards()
								end
						end
						interface.square_button = nil
					end
				end

				if interface.skills_interface.confirm_button.visible then
					local button = interface.skills_interface.confirm_button
					if (x>button.x and x<button.x+button.width) and (y>button.y and y<button.y+button.height) then
						local card_selected = interface.skills_interface.card_selected
						skills.apply_card(card_selected)
						interface.cards ={}
						interface.skills_interface.visible = false
						interface.skills_interface.confirm_button.visible = false
						interface.skills_interface.access_text=""
						actions.select_skills(interface.skills_interface.next_step)
					end
				end

				if actions.celldoor_overed>0 then
					tile = tiles.background_tiles[actions.celldoor_overed]
				elseif actions.tile_framed>0 then
					tile = tiles.background_tiles[actions.tile_framed]
				else
					tile = tiles.background_tiles[actions.tile_overed]
				end
				if tile ~= nil and tiles.player_step==0 then	
					if tile.luminosity>tiles.min_light then
						if actions.current_action == "disabled" then
							sounds.fail:play() 
						elseif path.is_vacant(actions.tile_overed,nil,true) and actions.current_action == "" then
							if actions.tile_overed == actions.tile_clicked and tiles.player_movement>0 then
								tiles.tile_clicked = 0
								if #tiles.next_player_movement > 0 then
									tiles.player_step = 1
								end					
							else
								tiles.tile_clicked = actions.tile_overed
								actions.tile_clicked = actions.tile_overed
								current_cursor = interface.cursor_move
			      			path.drawPath(tiles.background_tiles)
							end
			      	else
		      			if actions.current_action == "attack" or actions.current_action == "pick" or actions.current_action == "openchest" or actions.current_action == "pickchest"  or actions.current_action == "deactivatetrap" then	      				
		      				adjacent = path.get_adjacent(tiles.current_player_position,false,true,true)
		      				is_adjacent = helper.in_array(adjacent,actions.tile_overed)
		      				if is_adjacent then
									actions.tile_clicked = actions.tile_overed
									tiles.next_turn = actions.current_action
								else
			      				if actions.tile_overed == actions.tile_clicked and tiles.player_movement>0 then
										if #tiles.next_player_movement > 0 then
											tiles.player_step = 1
											tiles.next_action = actions.current_action
										end					
									else
										actions.tile_clicked = actions.tile_overed
					      			path.drawPath(tiles.background_tiles,false,nil,actions.tile_overed,nil,true)
			      				end
			      			end
		      			end
		      			if actions.current_action == "teleport" or actions.current_action == "victory" then	
		      				if actions.current_mode == "teleport" then
		      					actions.tile_clicked = actions.tile_overed
		      					tiles.next_turn = "teleport"
		      				elseif actions.tile_overed == actions.tile_clicked and tiles.player_movement>0 then
									if #tiles.next_player_movement > 0 then
										tiles.player_step = 1
										tiles.next_action = actions.current_action
									end					
								else
									actions.tile_clicked = actions.tile_overed
				      			path.drawPath(tiles.background_tiles,false,nil,actions.tile_overed,nil,false)
		      				end
			      		end
			      		if actions.current_action =="magic_attack" or actions.current_action =="scroll_attack" then
			      			actions.tile_clicked = actions.tile_overed
		      				tiles.next_turn = actions.current_action
			      		end
			      	end
		      	else
		      		if (actions.current_action == "teleport" or actions.current_action == "teleport_failed") and actions.current_mode == "teleport" then	
      					actions.tile_clicked = actions.tile_framed
      					tiles.next_turn = actions.current_action
		      		end
		      		if actions.current_action == "opencell" or actions.current_action == "pickcell"then							
		      			actions.celldoor_clicked = tiles.celldoor_overed	      			
		      			if actions.tile_overed == tiles.current_player_position then
								actions.tile_clicked = actions.tile_overed
								tiles.next_turn = actions.current_action
		      			elseif actions.tile_overed == actions.tile_clicked and tiles.player_movement>0 then
								if #tiles.next_player_movement > 0 then		
									tiles.player_step = 1
									tiles.next_action = actions.current_action
								end					
							else
			      			tiles.tile_clicked = actions.tile_overed
								actions.tile_clicked = tiles.tile_clicked
				      		player_path = path.drawPath(tiles.background_tiles)
				      	end
			      	end
			      	if actions.current_action == "magic_open" then							
		      			actions.celldoor_clicked = tiles.celldoor_overed	
		      			actions.tile_clicked = actions.tile_overed
							tiles.next_turn = actions.current_action 
			      	end
		      	end
				end
				if actions.current_action ~= "attack" and actions.current_action ~= "pick"  and actions.current_action ~= "opencell" and actions.current_action ~= "pickcell" then
					for tile_index, tile in ipairs(tiles.doors.N) do
						local over = isOvered(tile,x,y)
						if over and tile.luminosity>tiles.min_light and tiles.player_step==0 then
							if tile.adjacent == tiles.current_player_position and tiles.player_movement>0 then
								actions.exit_room("N")
							else
								if tile.adjacent == actions.tile_clicked and tiles.player_movement>0 then
									tiles.tile_clicked = 0
									if #tiles.next_player_movement > 0 then
										tiles.player_step = 1
										tiles.next_action = "exit"
										actions.next_room_direction = "N"
									end
						      	elseif path.is_vacant(tile.adjacent) then
									tiles.tile_clicked = tile.adjacent
									actions.tile_clicked = tile.adjacent
						      		path.drawPath(tiles.background_tiles)
						      	end
							end
						end
					end
					for tile_index, tile in ipairs(tiles.doors.E) do
						local over = isOvered(tile,x,y)
						if over and tile.luminosity>tiles.min_light and tiles.player_step==0 then
							if tile.adjacent == tiles.current_player_position and tiles.player_movement>0 then
								actions.exit_room("E")
							else
								if tile.adjacent == actions.tile_clicked and tiles.player_movement>0 then
									tiles.tile_clicked = 0
									if #tiles.next_player_movement > 0 then
										tiles.player_step = 1
										tiles.next_action = "exit"
										actions.next_room_direction = "E"
									end
						      	elseif path.is_vacant(tile.adjacent) then
									tiles.tile_clicked = tile.adjacent
									actions.tile_clicked = tile.adjacent
						      		path.drawPath(tiles.background_tiles)
						      	end
							end
						end
					end
					for tile_index, tile in ipairs(tiles.doors.S) do
						local over = isOvered(tile,x,y)
						if over and tile.luminosity>tiles.min_light and tiles.player_step==0 then
							if tile.adjacent == tiles.current_player_position and tiles.player_movement>0 then
								actions.exit_room("S")
							else
								if tile.adjacent == actions.tile_clicked and tiles.player_movement>0 then
									tiles.tile_clicked = 0
									if #tiles.next_player_movement > 0 then
										tiles.player_step = 1
										tiles.next_action = "exit"
										actions.next_room_direction = "S"
									end
						      	elseif path.is_vacant(tile.adjacent) then
									tiles.tile_clicked = tile.adjacent
									actions.tile_clicked = tile.adjacent
						      		path.drawPath(tiles.background_tiles)
						      	end
							end
						end
					end
					for tile_index, tile in ipairs(tiles.doors.W) do
						local over = isOvered(tile,x,y)
						if over and tile.luminosity>tiles.min_light and tiles.player_step==0 then
							if tile.adjacent == tiles.current_player_position and tiles.player_movement>0 then
								actions.exit_room("W")
							else
								if tile.adjacent == actions.tile_clicked and tiles.player_movement>0 then
									tiles.tile_clicked = 0
									if #tiles.next_player_movement > 0 then
										tiles.player_step = 1
										tiles.next_action = "exit"
										actions.next_room_direction = "W"
									end
						      	elseif path.is_vacant(tile.adjacent) then
									tiles.tile_clicked = tile.adjacent
									actions.tile_clicked = tile.adjacent
						      		path.drawPath(tiles.background_tiles)
						      	end
							end
						end
					end	
				end
			end	
			interface.setCursor(current_cursor)
		end	
		-- interface buttons
		for button_name,butt in pairs(interface.buttons) do 
	      if x>butt.x and x<butt.x+butt.width and y>butt.y and y<butt.y+butt.height then
	      	butt.state = "hover"
	      	if button_name == "menu" then
	      		if menu.escapable then
						menu.showmenu()
					end
				elseif button_name == "wait" then
		   		if tiles.turn == "player" then	   			
		   			actions.skip = true
		   			tiles.next_turn = "npcs"
		   		end
			   elseif button_name == "map" then
		   		map.showmap()
			   elseif button_name == "sheet" then
		   		sheet.showsheet()
			   end
	      end
	   end
	-- right mouse
	elseif button==2 then
		if actions.current_mode ~= "default" then
			actions.current_mode = "default"
			interface.setCursor(interface.cursor_default)
			sounds.fail:play() 
		end
		if actions.current_action == "opencell" or actions.current_action == "pickcell" then
			if helper.in_array(player.skills.abilities,"LOCKPICKING") then
				if actions.current_door_action == "opencell" then
					 actions.current_door_action = "pickcell"
					 actions.current_door_cursor = interface.cursor_lockpick
					 if actions.current_action == "opencell" then
					 	actions.current_action = "pickcell"
					 end
				else
					actions.current_door_action = "opencell"
					actions.current_door_cursor = interface.cursor_key
					if actions.current_action == "pickcell" then
					 	actions.current_action = "opencell"
					end
				end
				interface.setCursor(actions.current_door_cursor)
			end
		end
		if actions.current_action == "openchest" or actions.current_action == "pickchest" then
			if helper.in_array(player.skills.abilities,"LOCKPICKING") then
				if actions.current_chest_action == "openchest" then
					 actions.current_chest_action = "pickchest"
					 actions.current_chest_cursor = interface.cursor_lockpick
					if actions.current_action == "openchest" then
					 	actions.current_action = "pickchest"
					end
				else
					actions.current_chest_action = "openchest"
					actions.current_chest_cursor = interface.cursor_key
					if actions.current_action == "pickchest" then
					 	actions.current_action = "openchest"
					end
				end
				interface.setCursor(actions.current_chest_cursor)
			end
		end
		if interface.pending_inventory_card then
			table.insert(tiles.player.items,interface.pending_inventory_card)
			interface.pending_inventory_card = nil
			interface.sort_cards()
		end
	end
end

function actions.equip_card(card)
	local interface_card = {
			type= card.type,
		   subtype= card.subtype,
		   name= card.name,
		   desc= card.desc,
		   tile= card.tile,
		   value= card.value,
		   uses= card.uses,
		   modifier= {
		   	type=card.modifier.type,
		   	property=card.modifier.property,
		   	amount=card.modifier.amount,
		   	max=card.modifier.max,
		   	ambi=card.modifier.ambi,
		   	duration=card.modifier.duration,
		   	cost=card.modifier.cost,
		   	action=card.modifier.action
		   },
			sprite = interface.new_sprite(interface.inventory_card_width, interface.inventory_card_height, card.tile, interface.image_card_items_inventory, interface.inventory_card_tileset_width, interface.inventory_card_tileset_height)
		}
	table.insert(tiles.player.items,interface_card)
	helper.removeByIndex(interface.cards,card.index)
	effects.update_item_modifiers()
	if card.type == 'torch' then
		tiles.set_luminosity(tiles.current_room.lights,1,5)
	end
end

function actions.player_collision()
	for item_index, item in pairs(tiles.current_room.items) do
		if item.position == tiles.current_player_position then
			if item.action == "victory" or item.action == "teleport" then
				return item.action
			-- trap trigger
			elseif item.type ==  "Trap" and item.state == nil then
				return actions.trigger_trap(item)
			end
		end
	end
	return false
end

function actions.trigger_trap(item,npc)
	sounds.play_sound('trap_spike',tiles.current_player_position) 
	if not npc then
		local health = player.current_health-item.damage
		local p_sprite = tiles.sprites[tiles.current_player_position][rooms.level.special_items.player.layer]
		actions.hit_player(health,p_sprite.position,p_sprite)		
		tiles.next_turn = "npcs"
	end
	item.state = "triggered"
	tiles.change_tile(item.position,item.tile_triggered,tiles.image_items,item.layer, item.solid)
end

function actions.exit_room(direction,apparition)
	transition.fade("in-out","0.3","black",actions.exit_room_process,{direction=direction,apparition=apparition})
end

function actions.exit_room_process(...)
		local args={...}
		local direction = args[1].direction
		local apparition = args[1].apparition
		if direction then
			tiles.player_direction = direction
		end
		actions.tile_clicked = 0
		actions.tile_overed = 0
		actions.door_overed = {direction = 0, index = 0}
		if not apparition then
			if direction=="N" then
				rooms.current_room_location.y = rooms.current_room_location.y-1
				tiles.current_player_position = tiles.current_player_position + tiles.rows * (tiles.rows-1)
			elseif direction=="S" then
				rooms.current_room_location.y = rooms.current_room_location.y+1
				tiles.current_player_position = tiles.current_player_position - tiles.rows * (tiles.rows-1)
			elseif direction=="W" then
				rooms.current_room_location.x = rooms.current_room_location.x-1
				tiles.current_player_position = tiles.current_player_position - (tiles.rows-1)
			elseif direction=="E" then
				rooms.current_room_location.x = rooms.current_room_location.x+1
				tiles.current_player_position = tiles.current_player_position + (tiles.rows-1)
			end
		end
		-- level exit
		if rooms.current_room_location.y<1 or rooms.current_room_location.y>rooms.level.size.height or rooms.current_room_location.x<1  or rooms.current_room_location.x>rooms.level.size.width then
			actions.exit_level()
			tiles.next_turn = ""
		else
			local room = rooms.require_current_room()
			rooms.enter_room(room)
			tiles.next_player_movement = {}
			if apparition then
				tiles.next_turn = "player_teleport"
			else
				tiles.next_turn = "player_enter"
			end
			tiles.clear(room)
			tiles.construct_level(room,tiles.sprites,tiles.current_level,apparition,tiles.player_direction)		
			interface.update_compass()
		end
end

function actions.teleport()
	if actions.current_mode == "teleport" then
		helper.log(tiles.current_player_position.." // "..actions.tile_clicked)					
		tiles.current_player_position = actions.tile_clicked
		actions.exit_room_process({direction=direction,apparition=true})
		transition.fade("out",1,"black")
		sounds.teleport:play() 
		actions.current_mode = "default"
		print(interface.pending_inventory_card)
		if interface.pending_inventory_card then
			interface.pending_inventory_card = nil
	   else
	   	player.current_mana = player.current_mana - 1
	   end
	else
		for item_index, item in pairs(tiles.current_room.items) do
			if item.position == tiles.current_player_position then
				if item.action == "teleport" then
					rooms.current_room_location.x = tonumber(string.sub(item.destination.room,1,1))
					rooms.current_room_location.y = tonumber(string.sub(item.destination.room,2))						
					tiles.current_player_position = item.destination.position
					actions.exit_room_process({direction=direction,apparition=true})
					transition.fade("out",0.02,"black")
					sounds.teleport:play() 
				end
			end
		end
	end
end

function actions.teleport_failed()
	interface.show_icon(interface.icon_tiles.fail)
	sounds.fail:play() 
	helper.add_message(lang.msg_teleport_failed,love.mouse.getX(),love.mouse.getY()-100,2)
	actions.current_mode = "default"
   player.current_mana = player.current_mana-1
end

function actions.open_cell(task)
	for cell_index, cell in pairs( tiles.current_room.cells ) do
		if not cell.opened and cell.position==tiles.celldoor_overed and cell.position==actions.celldoor_clicked then
			if rooms.player_in_cell(cell) then
				celldoor_index = cell.door.cell_in
				celldoor_in = cell.door.cell_out
				player_is_in_cell = true
			else
				celldoor_index = cell.door.cell_out
				celldoor_in = cell.door.cell_in
				player_is_in_cell = false
			end
			tiles.player_direction = path.get_direction(path.get_coordinates(tiles.current_player_position),path.get_coordinates(celldoor_in))
			tiles.update_sprite(tiles.current_player_position,rooms.level.special_items.player.tile,tiles.image_player,rooms.level.special_items.player.layer,true,nil,tiles.player_direction)
			tiles.set_luminosity(tiles.current_room.lights,1,5)
			if celldoor_index == actions.tile_clicked then
				local success = false
				if task == "open" then
					if tiles.player.cellkeys > 0 then
						success = true
						tiles.player.cellkeys = tiles.player.cellkeys-1
					end
				elseif task == "pick" then
					if not cell.blocked then
						local roll = math.random(player.lockpicking+3)
						helper.log("Roll : "..roll.." Serrure : "..levels.current.cell_lock_level)
						if roll>levels.current.cell_lock_level then
							success = true
						end
					else
						helper.add_message(lang.msg_lockblocked,love.mouse.getX(),love.mouse.getY()-100,2)
					end
				elseif task == "magic" then
					local roll = math.random(player.mana)
					if interface.pending_inventory_card then
						roll = 999
						interface.pending_inventory_card = nil
				   else
				   	player.current_mana = player.current_mana - 1
				   end
					helper.log("Roll : "..roll.." Serrure : "..levels.current.cell_lock_level)
					if roll>levels.current.cell_lock_level then
						success = true
					end
					actions.current_mode = "default"					
				end
				if success then
					if player_is_in_cell then
						tiles.current_room.hall.lighted = true
						for __, othercell in pairs( tiles.current_room.cells ) do
							if othercell.opened then
								othercell.lighted = true
							end
						end
					else
						cell.lighted = true
					end
					cell.opened = true
					cell.unlocked = true
					local room = rooms.require_current_room()
					helper.log("Salle : "..rooms.current_room_location.x..rooms.current_room_location.y)
					tiles.clear(room)
					tiles.construct_level(room,tiles.sprites)
					sounds.play_sound('door_open',tiles.current_player_position)
					effects.alert_npcs(1)
					map.drawmap()
					transition.fade("out","1","black")
				else
					if task == "pick" then
						cell.blocked = true
					end
					interface.show_icon(interface.icon_tiles.fail)
					sounds.fail:play() 
					actions.skip = true
				end
			end
		end
	end
end

function actions.pick(lockpick)
	tiles.player_direction = path.get_direction(path.get_coordinates(tiles.current_player_position),path.get_coordinates(actions.tile_clicked))
	tiles.update_sprite(tiles.current_player_position,rooms.level.special_items.player.tile,tiles.image_player,rooms.level.special_items.player.layer,true,nil,tiles.player_direction)
	tiles.set_luminosity(tiles.current_room.lights,1,5)
	for item_index, item in pairs(tiles.current_room.items) do
		if actions.tile_clicked == item.position then
			if (item.type == "Chest" and (not item.state or item.state ~= "opened")) or item.type == "Barrel" then
				actions.open_chest(item,lockpick)
			elseif item.type == "Health" or item.type == "Mana" then
				effects.drink_fountain(item)
			elseif (item.type == "Chest" and (item.state and item.state == "opened")) or item.type == "Purse" then
				item.index = item_index
				actions.open_purse(item)
			end
		end
	end
end

function actions.open_chest(chest,lockpick)
	chest_opened = false
	if chest.state == nil and (tiles.player.chestkeys>0 or chest.type=="Barrel") then
		chest_opened = true
	end
	if chest.type=="Chest" and lockpick then
		if not chest.blocked then
			local roll = math.random(player.lockpicking+3)
			helper.log("Roll : "..roll.." Serrure : "..levels.current.chest_lock_level)
			if roll>levels.current.chest_lock_level then
				chest_opened = true
			else
				chest.blocked = true
				chest_opened = false
			end
		else
			helper.add_message(lang.msg_lockblocked,love.mouse.getX(),love.mouse.getY()-100,2)
			chest_opened = false
		end
	end
	if chest_opened then
		local chest_index = nil
		if chest.type=="Chest" and not lockpick then
			tiles.player.chestkeys = tiles.player.chestkeys -1
		end
		chest.state = "opened"
		chest_sprite = tiles.sprites[chest.position][chest.layer]
		chest.x = chest_sprite.position.x
		chest.y = chest_sprite.position.y
		chest = actions.get_booty(chest)
		for item_index,item in pairs(tiles.current_room.items) do
			if chest.position == item.position then
				--tiles.current_room.items[item_index] = chest
				chest_index = item_index
			end
		end
		if chest.type=="Barrel" then
			sounds.play_sound('barrel_break',chest.position) 
			effects.alert_npcs(2)
			chest.type = "Decor"
			chest.action = nil
			if chest.subtype=="Crate" then
				tiles.sprites[chest.position][chest.layer] = nil
				-- tiles.current_room.items[chest_index] = nil
				tiles.current_room.decor[chest_index] = chest
				chest.solid = false
				chest.layer = 1
			end
		else
			sounds.play_sound('chest_open',chest.position) 
		end
		tiles.change_tile(chest.position,chest.tile_opened,tiles.image_items,chest.layer, chest.solid)
	else
		interface.show_icon(interface.icon_tiles.fail)
		sounds.fail:play()
	end
end

function actions.open_purse(item)
	actions.current_action = nil
	for card_index, card in pairs(item.booty) do		
		table.remove(item.booty,card_index)
		card.purse_index = item.position
		interface.add_card(card,interface.image_card_items)
	end
	if #item.booty < 1 then
		if item.type == "Purse" then
			for key, val in pairs(item) do
				tiles.current_room.items[item.index] = nil
				tiles.sprites[item.position][item.layer] = nil
			end
		elseif item.type == "Chest" then
			item.action = false
		end
	end
end

function actions.deactivate_trap()
	local items = tiles.get_tile_items(actions.tile_clicked)
	for i,item in pairs(items.items) do
		if item.type == "Trap" and item.state == nil and helper.in_array(player.skills.abilities,"TRAPDEACTIVATION") then
			if not item.blocked then
				local roll = math.random(player.trap_deactivation+5)
				helper.log("Roll : "..roll.." Piège : "..levels.current.trap_deactivation_level)
				if roll>levels.current.trap_deactivation_level then
					item.state = "deactivated"
					helper.add_message(lang.msg_trapdeactivated,love.mouse.getX(),love.mouse.getY()-100,2)
				else
					item.blocked = true
					interface.show_icon(interface.icon_tiles.fail)
					sounds.fail:play()
				end
			else
				helper.add_message(lang.msg_trapblocked,love.mouse.getX(),love.mouse.getY()-100,2)
				interface.show_icon(interface.icon_tiles.fail)
				sounds.fail:play()
			end			
		end
	end
end

function actions.show_traps()
	local traps_shown = 0
	for i,item in pairs(tiles.current_room.items) do
		if item.type == "Trap" and item.state == nil then
			local reachable = path.is_in_same_cell(tiles.current_player_position,item.position)
			if reachable then
				local sprite = tiles.sprites[item.position][item.layer]	
				sprite.rgb = {1,0,0}
				local tile = tiles.background_tiles[item.position]
				tile.rgb = {0.5,0,0}
				traps_shown = traps_shown + 1
			end
		end
	end
	tiles.next_turn = "npcs"
end

function actions.magic_attack(scroll)
	local ennemy
	local barrel
	for npc_index, npc in pairs(tiles.current_room.npcs) do
		if actions.tile_clicked == npc.position then
			ennemy = npc
			ennemy.index = npc_index
		end
	end
	-- Annulé pour l'instant : problème récupération pièces ou clés
	--[[ 
	for _, item in pairs( tiles.current_room.items ) do 
		if actions.tile_clicked == item.position then
			if item.type == "Barrel" then
				barrel = item
			end
		end
	end
	]]
	if ennemy then
		local result = actions.magic_fight(ennemy,scroll)
		local e_sprite = tiles.sprites[ennemy.position][ennemy.layer]
		if result < ennemy.health then
			if result <= 0 then
				-- ennemy killed
				sounds.play_sound('monster_dead',ennemy.position,true) 
				helper.add_message(lang.msg_ennemykilled,e_sprite.position.x,e_sprite.position.y,2,"purple")
				interface.show_icon(interface.icon_tiles.npc_dead)	
				dead_npc = ennemy
				dead_npc.alpha = 1
				dead_npc.x = e_sprite.position.x
				dead_npc.y = e_sprite.position.y
				table.insert(actions.dead_npcs,dead_npc)
				tiles.current_room.npcs[ennemy.index] = nil
				e_sprite.move_up = 1
				if ennemy.action == "victory" then
					actions.exit_level()
				end
			else
				-- ennemy wounded
				sounds.play_sound('monster_wounded',ennemy.position,true) 
				helper.add_message(lang.msg_ennemywounded,e_sprite.position.x,e_sprite.position.y,2,"purple")
				interface.show_icon(interface.icon_tiles.npc_wounded)	
				ennemy.health = result
				tiles.current_room.npcs[ennemy.index] = ennemy
			end
			e_sprite.rgb = {1,0,0}
			e_sprite.hit = true
		else
			-- missed
			helper.add_message(lang.msg_missed,e_sprite.position.x,e_sprite.position.y,2)
			interface.show_icon(interface.icon_tiles.missed)		
			actions.debug = actions.debug.."\r\nRaté"
		end		
	end
	actions.current_mode = "default"
	if scroll then
		interface.pending_inventory_card = nil
   else
   	player.current_mana = player.current_mana - 1
   end
	effects.alert_npcs(1)
end

function actions.magic_fight(ennemy,scroll)
	sounds.play_sound('magic_attack',ennemy.position) 
	local bolt = tiles.add_flashing_item("bolt",ennemy.position)
	tiles.halo_appearing = true
	local roll = math.random(tiles.player.mana)
	if scroll then
		roll = 999
	end
	local ennemy_health = ennemy.health
	if roll > ennemy.defense then
		ennemy_health = ennemy_health-1
	end
	helper.log("Attaque : "..tiles.player.mana.." Jet : "..roll.." VS Déf. : "..ennemy.defense)
	return ennemy_health
end

function actions.attack(ennemy)
	local attacker
	if not ennemy then
		attacker = "P"
		for npc_index, npc in pairs(tiles.current_room.npcs) do
			if actions.tile_clicked == npc.position then
				ennemy = npc
				ennemy.index = npc_index
			end
		end
		tiles.player_direction = path.get_direction(path.get_coordinates(tiles.current_player_position),path.get_coordinates(actions.tile_clicked))
		tiles.update_sprite(tiles.current_player_position,rooms.level.special_items.player.tile,tiles.image_player,rooms.level.special_items.player.layer,true,nil,tiles.player_direction)
	else
		if ennemy.hostility<2 then			
			return
		end
		attacker = "E"
		ennemy.direction = path.get_direction(path.get_coordinates(ennemy.position),path.get_coordinates(tiles.current_player_position))
		tiles.update_sprite(ennemy.position,ennemy.tile,nil,ennemy.layer,true,nil,ennemy.direction)
	end
	tiles.set_luminosity(tiles.current_room.lights,1,5)
	if ennemy then
		local result = actions.fight(ennemy,attacker)
		local e_sprite = tiles.sprites[ennemy.position][ennemy.layer]
		local p_sprite = tiles.sprites[tiles.current_player_position][rooms.level.special_items.player.layer]
		if result.e < ennemy.health then
			if result.e <= 0 then
				-- ennemy killed
				sounds.play_sound('monster_dead',ennemy.position,true) 
				helper.add_message(lang.msg_ennemykilled,e_sprite.position.x,e_sprite.position.y,2,"purple")
				interface.show_icon(interface.icon_tiles.npc_dead)	
				dead_npc = ennemy
				dead_npc.alpha = 1
				dead_npc.x = e_sprite.position.x
				dead_npc.y = e_sprite.position.y
				table.insert(actions.dead_npcs,dead_npc)
				tiles.current_room.npcs[ennemy.index] = nil
				actions.tile_clicked = 0
				e_sprite.move_up = 1
				if ennemy.action == "victory" then
					actions.exit_level()
					tiles.next_turn = ""
				end
			else
				-- ennemy wounded
				sounds.play_sound('monster_wounded',ennemy.position,true) 
				helper.add_message(lang.msg_ennemywounded,e_sprite.position.x,e_sprite.position.y,2,"purple")
				interface.show_icon(interface.icon_tiles.npc_wounded)	
				ennemy.health = result.e
				tiles.current_room.npcs[ennemy.index] = ennemy
			end
			e_sprite.rgb = {1,0,0}
			e_sprite.hit = true
		elseif p_sprite and result.p < tiles.player.current_health then
			if result.p <= 0 then
				-- player killed
				actions.hit_player(result.p,p_sprite.position,p_sprite)
			else
				-- player wounded
				-- dodge ability (10% / point)
				local dodged = false
				local roll = math.random(10)
				helper.log(roll.." / "..tostring(player.dodge))
				if player.dodge and roll<= player.dodge then
					helper.add_message(lang.msg_attackdodged,p_sprite.position.x,p_sprite.position.y,2)
					dodged = true
				end
				-- robustness ability+spell (10% / point)
				absorbed = false
				roll = math.random(10)
				helper.log(roll.." / "..tostring(player.robustness).."+"..player.modifiers.robustness)
				local robustness = player.robustness + player.modifiers.robustness
				if not dodged and robustness>0 and roll <= robustness then
					helper.add_message(lang.msg_woundabsorbed,p_sprite.position.x,p_sprite.position.y,2)
					absorbed = true
				end
				if not dodged and ennemy.poison then
					local roll = math.random(player.defaults.resistance)
					if roll <= ennemy.poison.level then
						helper.add_message(lang.msg_poisoned,p_sprite.position.x+p_sprite.width,p_sprite.position.y,2,"red")
						interface.show_icon(interface.icon_tiles.poisoned)	
						effects.add_modifier(ennemy.poison.property,ennemy.poison)
						effects.update_modifiers()
					end
				end
				if not dodged and not absorbed then
					actions.hit_player(result.p,p_sprite.position,p_sprite)
				end
			end
		else
			-- missed
			helper.add_message(lang.msg_missed,e_sprite.position.x,e_sprite.position.y,2)
			interface.show_icon(interface.icon_tiles.missed)		
			actions.debug = actions.debug.."\r\nRaté"
		end
		-- outnumber malus
		if tiles.player.combat-actions.attack_malus > 2 then
			actions.attack_malus = actions.attack_malus +1
		end
		effects.alert_npcs(1)
		if attacker == "P" then
			tiles.next_turn = "npcs"
		end
	else
		tiles.next_turn = false
	end
end

function actions.hit_player(health,position,sprite)
	sprite.rgb = {1,0,0}
	sprite.hit = true
	if health <= 0 then
		-- player killed
		sounds.play_sound('player_dead',tiles.current_player_position) 
		helper.add_message(lang.msg_playerdead,position.x,position.y,2,"red")
		interface.show_icon(interface.icon_tiles.player_dead)		
		tiles.player.current_health = 0
		tiles.next_turn = false
		if helper.mode == "prod" then
			transition.fade("in","0.005","red")
			menu.alertmenu("msg_playerdead","menu_quit","home")
			tiles.turn = nil
		end
	else
		sounds.play_sound('player_wounded',tiles.current_player_position) 
		helper.add_message(lang.msg_playerwounded,position.x,position.y,2,"red")
		interface.show_icon(interface.icon_tiles.player_wounded)		
		tiles.player.current_health = health
	end
end

function actions.fight(ennemy,attacker)
	sounds.play_sound('sword',tiles.current_player_position) 
	-- melee ability
	local attack_malus = actions.attack_malus
	if player.melee and attack_malus then
		helper.log("Malus mêlée : "..attack_malus.." - "..player.melee)
		if attack_malus-player.melee >= 0 then
			attack_malus = attack_malus-player.melee
		end
	end
	-- charge ability
	local charge_bonus = 0
	if attacker == "P" and player.charge and #player.last_movement>actions.charge_threshold then
		charge_bonus = math.ceil((#player.last_movement-actions.charge_threshold)*player.charge)
		helper.log("Charge : "..player.charge.." - Distance : "..#player.last_movement.." - Bonus : "..charge_bonus)
	end
	local roll = math.random(tiles.player.combat+player.modifiers.combat+player.item_modifiers.combat+charge_bonus-attack_malus)
	local direction_modifier = path.get_direction_modifier(ennemy,attacker)
	-- vigilance and suppleness ability
	if player.rear_defence and attacker == "E" and direction_modifier<0 then
		if direction_modifier + player.rear_defence >=0 then
			direction_modifier = 0
		else
			direction_modifier = direction_modifier + player.rear_defence
		end
	end
	-- assassination ability
	if player.assassination and attacker == "P" and direction_modifier>0 then
			direction_modifier = direction_modifier + player.assassination
	end
	local health_modifier = 0
	if not player.paincontrol and player.current_health == 1 then
		health_modifier = -1
		helper.log("Santé -> -1")
	elseif player.paincontrol and player.current_health == 1 then		
		helper.log("Contrôle de la douleur -> 0")
	end
	roll = roll + direction_modifier + health_modifier
	local player_health = tiles.player.current_health
	local ennemy_health = ennemy.health
	if roll > ennemy.defense then
		ennemy_health = ennemy_health-1
	end
	if roll <= ennemy.attack then
		player_health = player_health-1
	end
	helper.log("Attaque : "..tiles.player.combat+player.modifiers.combat+player.item_modifiers.combat-attack_malus.." Jet : "..roll.." ("..direction_modifier..") VS Déf. : "..ennemy.defense.." Att. : "..ennemy.attack)
	return {p=player_health,e=ennemy_health}
end

function actions.get_booty(npc)
	booty_log = ""
	msg_y = npc.y - 20
	if npc.max_gold>0 then
		local min = 0
		if npc.min_gold then
			min = npc.min_gold
		end
		gold_amount = math.random(min,npc.max_gold)
		if gold_amount > 0 then
			tiles.player.gold = tiles.player.gold + gold_amount
			interface.show_icon(interface.icon_tiles.gold)			
			helper.add_message("+ "..gold_amount.." "..lang.word_gold,npc.x,msg_y,2,"yellow") 
			msg_y = msg_y - 20
		end
	end
	if npc.max_chestkey>0 then
		local min = 0
		if npc.min_chestkey then
			min = npc.min_chestkey
		end
		chestkey_amount = math.random(min,npc.max_chestkey)
		if chestkey_amount > 0 then
			tiles.player.chestkeys = tiles.player.chestkeys + chestkey_amount
			interface.show_icon(interface.icon_tiles.chestkey)
			helper.add_message("+ "..chestkey_amount..lang.word_chestkey,npc.x,msg_y,2,"yellow") 
			msg_y = msg_y - 20
		end
	end
	if npc.max_cellkey>0 then
		local min = 0
		if npc.min_cellkey then
			min = npc.min_cellkey
		end
		cellkey_amount = math.random(min,npc.max_cellkey)
		if cellkey_amount > 0 then
			tiles.player.cellkeys = tiles.player.cellkeys + cellkey_amount
			interface.show_icon(interface.icon_tiles.cellkey)
			helper.add_message("+ "..cellkey_amount..lang.word_cellkey,npc.x,msg_y,2,"yellow") 
		end
	end
	if npc.type == "Chest" then
		npc.booty = {}
	end
	if npc.max_items>0 or npc.special_item then
		items_amount = math.random(0,npc.max_items)
		if items_amount > 0 or npc.special_item then
			if #rooms.level.card_items_deck>0 or npc.special_item then
				local purse
				if npc.type ~= "Chest" then
					purse = {
									type="Purse",
							      tile=rooms.level.special_items.purse.tile,
							      solid=rooms.level.special_items.purse.solid,
							      layer=rooms.level.special_items.purse.layer,
							      booty={},
							      action=rooms.level.special_items.purse.action
								}
					purse.position = npc.position
				end
				if items_amount > 0 then
					for i=1,items_amount do
						local card = table.remove(rooms.level.card_items_deck)
						if npc.type == "Chest" then
							table.insert(npc.booty,card)
						else
							table.insert(purse.booty,card)
						end
					end
				end
				if npc.special_item then
					local card = rooms.level.special_card_items[npc.special_item]
					if npc.type == "Chest" then
						table.insert(npc.booty,card)
					else
						table.insert(purse.booty,card)
					end
				end
				if npc.type ~= "Chest" then
					tiles.current_room.items[npc.position] = purse
					tiles.change_tile(npc.position,purse.tile,tiles.image_items,purse.layer, purse.solid)
				end
			end
		end
	end
	return npc
end

function actions.exit_level()
	local x = love.graphics.getWidth() - interface.image_bg_topright:getWidth() - 40
	local y = 50
	helper.add_message(lang.msg_levelfinished,x,y,1) 
	sounds.victory:play()
	if levels.current.objectives.endgame then
		menu.alertmenu("level_endgame","menu_quit","home")
	else
		print("Niveau actuel : "..tostring(levels.current_level))
		levels.current_level = levels.current_level +1
		print("Nouveau niveau : "..tostring(levels.current_level))
		actions.savegame()
		local endtext =  levels.current.objectives.endtext
		menu.alertmenu(endtext,"level_nextlevel","startlevel")
	end
end

function actions.startlevel(loadgame)
	rooms.current_room = 1
	if loadgame then
		local is_saved = love.filesystem.getInfo("save")
		if is_saved then
			local gamedata = love.filesystem.read("string","save")
			gamedata = binser.deserializeN(gamedata)
			levels.current_level = gamedata.level
			player.loadtable(gamedata.player)
		else
			player.reset();
		end
	end
	-- levels.current_level = 3
	print("Démarrage niveau : "..tostring(levels.current_level))
	local test_level = 50
	local level
	local room
	for x=1,test_level do
		level = levels.require_current_level(levels.current_level)
		rooms.level = level	
	   tiles.init()
	   rooms.init()
	   player.init(level.reset.player)
	   rooms.set_start_location()
	   rooms.cells_model = cells[level.cell_model]
	   room = rooms.require_current_room(levels.current_level)
	   rooms.enter_room(room)
	   rooms.build_level()
	   local conditions = 0
	   local filled = 0
	   -- level conditions
	   for table_type,condition in pairs(levels.current.conditions) do
	   	for k,crit in pairs(condition) do
		   	local cond = rooms.find_item(table_type,crit.attr,crit.val)
		   	if #cond >= crit.min then
		   		filled = filled + 1
		   	end
		  		conditions = conditions + 1
		  	end
	   end
	   -- portal count must be even
	   conditions = conditions + 1
	   local portals = rooms.find_item("items","type","Portal")
	   if (#portals == 0 or #portals % 2 == 0) then
	   	filled = filled + 1
	   end
	   -- print('#'..x.." Conditions : "..filled.."/"..conditions.." Portals : "..#portals)
	   if filled == conditions then
	   	break
	   end
	 end
   tiles.current_player_position = level.player_start_position
   tiles.player = player
   tiles.player_direction = path.get_player_direction(tiles.current_player_position)
   local sprites = sprites.require_current_sprites(room,tiles.current_player_position)
   tiles.construct_level(room,sprites,level,false)
   interface.init()
   transition.draw_background()
   interface.title_level.text = lang["level_title_"..tostring(levels.current_level)]
   love.audio.stop(sounds.game_music)
   sounds.game_music = love.audio.newSource("sounds/"..level.music, "stream")
   love.audio.play(sounds.game_music)
   sounds.game_music:setVolume(config.music_volume)
	menu.init("game") 
	menu.visible = false  	
	interface.sort_cards()
	local starttext =  "level_text_"..tostring(levels.current_level)
   menu.alertmenu(starttext,"menu_continue","skills","intro")
   effects.update_item_modifiers()
end

function actions.select_skills(skilltype_index)
	if not skilltype_index then
		skilltype_index = 1
	end
	interface.hide_skills_interface()
	if levels.current.skills and #levels.current.skills and skilltype_index <= #levels.current.skills then
		local skill_type = levels.current.skills[skilltype_index]
		local skills = skills.get_cards(skill_type,skilltype_index)
	else
		interface.hide_skills_interface()
		local starttext =  levels.current.objectives.starttext
   	menu.alertmenu(starttext,"level_startlevel","newturn")
   	transition.fade('out',0.005,"image")
	end
end

function actions.savegame()
	local gamedata = {level = levels.current_level, player = player.gettable() }
	local data = binser.serialize(gamedata)
	love.filesystem.write("save",data)
end

function actions.move_npcs()
	-- unwalkable = {tiles.current_player_position}
	local unwalkable = {}
	for _, npc in pairs( tiles.current_room.npcs ) do 
		local is_free = true
		local is_player_free = true
		local npc_cell = 0
		local player_cell = 0
		for cell_index, cell in ipairs( tiles.current_room.cells ) do
			if not cell.opened then
				for tile_index, tile in pairs(cell.tiles) do
					if tile == npc.position then
						is_free = false
						npc_cell = cell_index
					end
					if tile == tiles.current_player_position then
						is_player_free = false
						player_cell = cell_index
					end
				end
			end
		end
		if not is_player_free then
			if is_free then
				is_free = false
			elseif npc_cell == player_cell then
				is_free = true
			end
		end
		if is_free then
			local npc_target 
			local distance = path.drawPath(tiles.background_tiles,true,npc.position,tiles.current_player_position,unwalkable,true)
			if distance then
				if #distance <= npc.vigilance-player.stealth-player.modifiers.stealth then
					npc.hostility = npc.hostility + 1
				end
				if npc.hostility > 1 then
					npc_target = tiles.current_player_position
				else
					local npc_cell = rooms.get_cell_from_position(npc.position,tiles.current_room)
					npc_target = rooms.set_item_position(tiles.current_room,"npc","all",npc_cell)
				end
			end
			shortest_path = path.drawPath(tiles.background_tiles,true,npc.position,npc_target,unwalkable,true)
			if shortest_path and #shortest_path>0 then				
				-- table.remove(shortest_path)
				npc.path = shortest_path
				table.insert(tiles.npcs_movements,npc)
				if npc.speed > #shortest_path then
					npc.position = shortest_path[#shortest_path].position
				else
					npc.position = shortest_path[npc.speed].position
				end
				table.insert(unwalkable,npc.position)
			end
		end
	end
	tiles.npc_step = 1	
	-- check path
	for _, step in ipairs(tiles.next_player_movement) do
		for __, tile in pairs(unwalkable) do
			if step == tile then
				tiles.next_player_movement = {}
				tiles.tile_clicked = 0
				break
			end
		end
	end
	if #tiles.npcs_movements==0 then
		tiles.next_turn = "player"
	end
end

function actions.npc_follow()
	for _, npc in pairs( tiles.current_room.npcs ) do 
		local adjacent = path.get_adjacent(tiles.current_player_position,false,true,true)
		local is_adjacent = helper.in_array(adjacent,npc.position)
		helper.log(helper.dump(adjacent).." : "..tostring(npc.position))
		helper.log("Angle : "..path.get_direction_modifier(npc,"P"))
		if is_adjacent then
			helper.log(tiles.player_direction)
			local direction = path.get_direction(path.get_coordinates(npc.position),path.get_coordinates(tiles.current_player_position))
			if path.in_fov(npc.direction,direction) then
				npc.direction = direction
				tiles.update_sprite(npc.position,npc.tile,nil,3,true,nil,npc.direction)
				tiles.set_luminosity(tiles.current_room.lights,1,5)
				npc.hostility = npc.hostility + 1
			end
		end
	end
end

function actions.newturn(player,reset_movement)
	map.drawmap()
	if reset_movement then
		tiles.player_movement = player.movement+player.modifiers.movement+player.item_modifiers.movement
		if #tiles.next_player_movement > 0 then
			tiles.tile_clicked = tiles.next_player_movement[#tiles.next_player_movement].position
		end
	else
		if tiles.player_movement < 1 then
			tiles.next_turn = "npcs"
		end
	end
	-- start music over
	if not sounds.game_music:isPlaying() then
		love.audio.play(sounds.game_music)
	end
	path.drawPath(tiles.background_tiles)
	if actions.skip then
		actions.skip = false
	else
		effects.update_modifiers()
	end
end

function isOvered(tile,x,y)
	if x>=tile.position.x and x<=tile.position.x+tile.width and y>=tile.position.y and y<=tile.position.y+tile.height then
		local qw = tile.width/2
		local qh = tile.height/2
		local r = qw/qh
		--up left
		local rx = x-tile.position.x
		local ry = y-tile.position.y
		if rx<= qw and ry<= qh then
			if rx/r+ry>=qh then
				return true
			end
		end
		--up right
		if rx> qw and ry<= qh then
			if rx<=y*r then
				return true
			end
		end
		--down left
		if rx<= qw and ry> qh then
			ry = ry - qh
			if rx>=ry*r then
				return true
			end
		end
		--down right
		if rx> qw and ry> qh then
			rx = rx - qw
			ry = ry - qh
			if rx/r+ry<=qh then
				return true
			end
		end
	end
end


return actions