local cells = {}
cells.indoor = {
   NS = {
      walls = {
         tile= {"00","01","05"}
      },
      walls_edge = {
         tile= {"00","06"}
      },
      walls_type = "random",
      walls_edge_type = "sequence",
      doors = {
         tile_opened= "02",
         tile_closed= "03",
         tile_unlocked= "04"
      }
   },
   WE = {
      walls = {
         tile= {"10","11","15"}
      },
      walls_edge = {
         tile= {"10","16"}
      },
      walls_type = "random",
      walls_edge_type = "sequence",
      doors = {
         tile_opened= "12",
         tile_closed= "13",
         tile_unlocked= "14"
      }
   },
   safe_tiles = {1,2,3,5,6,7,8,9,10,12,13,14,15,16,17,19,20,21,29,30,31,33,34,35,36,37,38,40,41,42,43,44,45,47,48,49},
   NW =  
   {
      position = "NW",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {5,6,7,12,13,14,19,20,21},
      walls = {
         {
            tile= {"00","01"},
            positions = {26,27,28}
         },
         {
            tile= {"10","11"},
            positions = {5,12,19}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 27,
            cell_in = 20,
            cell_out = 27
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 12,
            cell_in = 12,
            cell_out = 11
         }
      }
   },
   NE =  
   {
      position = "NE",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {1,2,3,8,9,10,15,16,17},
      walls = {
         {
            tile= {"00","01"},
            positions = {22,23,24}
         },
         {
            tile= {"10","11"},
            positions = {4,11,18}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 23,
            cell_in = 16,
            cell_out = 23
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 11,
            cell_in = 10,
            cell_out = 11
         }
      }
   },
   SW =  
   {
      position = "SW",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {33,34,35,40,41,42,47,48,49},
      walls = {
         {
            tile= {"00","01"},
            positions = {33,34,35}
         },
         {
            tile= {"10","11"},
            positions = {33,40,47}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 34,
            cell_in = 34,
            cell_out = 27
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 40,
            cell_in = 40,
            cell_out = 39
         }
      }
   },
   SE =  
   {
      position = "SE",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {29,30,31,36,37,38,43,44,45},
      walls = {
         {
            tile= {"00","01"},
            positions = {29,30,31}
         },
         {
            tile= {"10","11"},
            positions = {32,39,46}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 30,
            cell_in = 30,
            cell_out = 23
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 39,
            cell_in = 38,
            cell_out = 39
         }
      }
   },
   N =  
   {
      position = "N",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21},
      walls = {
         {
            tile= {"00","01"},
            positions = {22,23,24,25,26,27,28}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 27,
            cell_in = 20,
            cell_out = 27
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 25,
            cell_in = 18,
            cell_out = 25
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 23,
            cell_in = 16,
            cell_out = 23
         }
      }
   },
   S =  
   {
      position = "S",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49},
      walls = {
         {
            tile= {"00","01"},
            positions = {29,30,31,32,33,34,35}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 34,
            cell_in = 34,
            cell_out = 27
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 32,
            cell_in = 32,
            cell_out = 25
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 30,
            cell_in = 30,
            cell_out = 23
         }
      }
   },
   W =  
   {
      position = "W",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {5,6,7,12,13,14,19,20,21,26,27,28,33,34,35,40,41,42,47,48,49},
      walls = {
         {},
         {
            tile= {"10","11"},
            positions = {5,12,19,26,33,40,47}
         }
      },
      doors = {
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 12,
            cell_in = 12,
            cell_out = 11
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 26,
            cell_in = 26,
            cell_out = 25
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 40,
            cell_in = 40,
            cell_out = 39
         }
      }
   },
   E =  
   {
      position = "E",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {1,2,3,8,9,10,15,16,17,22,23,24,29,30,31,36,37,38,43,44,45},
      walls = {
         {},
         {
            tile= {"10","11"},
            positions = {4,11,18,25,32,39,46}
         }
      },
      doors = {
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 11,
            cell_in = 10,
            cell_out = 11
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 25,
            cell_in = 24,
            cell_out = 25
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 39,
            cell_in = 38,
            cell_out = 39
         }
      }
   },
   C =  
   {
      position = "C",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {17,18,19,24,25,26,31,32,33},
      walls = {
         {
            tile= {"00","01"},
            positions = {17,18,19}
         },
         {
            tile= {"10","11"},
            positions = {17,24,31}
         },
         {
            tile= {"00","01"},
            positions = {38,39,40}
         },
         {
            tile= {"10","11"},
            positions = {20,27,34}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 18,
            cell_in = 18,
            cell_out = 11
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 39,
            cell_in = 32,
            cell_out = 39
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 27,
            cell_in = 26,
            cell_out = 27
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 24,
            cell_in = 24,
            cell_out = 23
         }
      }
   }
}
cells.outdoor = {
   NS = {
      walls = {
         tile= {"00","01","05"}
      },
      walls_edge = {
         tile= {"06","07"}
      },
      walls_type = "random",
      walls_edge_type = "sequence",
      doors = {
         tile_opened= "02",
         tile_closed= "03",
         tile_unlocked= "04"
      }
   },
   WE = {
      walls = {
         tile= {"10","11","15"}
      },
      walls_edge = {
         tile= {"16","17"}
      },
      walls_type = "random",
      walls_edge_type = "sequence",
      doors = {
         tile_opened= "12",
         tile_closed= "13",
         tile_unlocked= "14"
      }
   },
   safe_tiles = {1,2,3,5,6,7,8,9,10,12,13,14,15,16,17,19,20,21,29,30,31,33,34,35,36,37,38,40,41,42,43,44,45,47,48,49},
   NW =  
   {
      position = "NW",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {5,6,7,12,13,14,19,20,21},
      walls = {
         {
            tile= {"00","01"},
            positions = {26,27,28}
         },
         {
            tile= {"10","11"},
            positions = {5,12,19}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 27,
            cell_in = 20,
            cell_out = 27
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 12,
            cell_in = 12,
            cell_out = 11
         }
      }
   },
   NE =  
   {
      position = "NE",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {1,2,3,8,9,10,15,16,17},
      walls = {
         {
            tile= {"00","01"},
            positions = {22,23,24}
         },
         {
            tile= {"10","11"},
            positions = {4,11,18}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 23,
            cell_in = 16,
            cell_out = 23
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 11,
            cell_in = 10,
            cell_out = 11
         }
      }
   },
   SW =  
   {
      position = "SW",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {33,34,35,40,41,42,47,48,49},
      walls = {
         {
            tile= {"00","01"},
            positions = {33,34,35}
         },
         {
            tile= {"10","11"},
            positions = {33,40,47}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 34,
            cell_in = 34,
            cell_out = 27
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 40,
            cell_in = 40,
            cell_out = 39
         }
      }
   },
   SE =  
   {
      position = "SE",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {29,30,31,36,37,38,43,44,45},
      walls = {
         {
            tile= {"00","01"},
            positions = {29,30,31}
         },
         {
            tile= {"10","11"},
            positions = {32,39,46}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 30,
            cell_in = 30,
            cell_out = 23
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 39,
            cell_in = 38,
            cell_out = 39
         }
      }
   },
   N =  
   {
      position = "N",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21},
      walls = {
         {
            tile= {"00","01"},
            positions = {22,23,24,25,26,27,28}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 27,
            cell_in = 20,
            cell_out = 27
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 25,
            cell_in = 18,
            cell_out = 25
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 23,
            cell_in = 16,
            cell_out = 23
         }
      }
   },
   S =  
   {
      position = "S",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49},
      walls = {
         {
            tile= {"00","01"},
            positions = {29,30,31,32,33,34,35}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 34,
            cell_in = 34,
            cell_out = 27
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 32,
            cell_in = 32,
            cell_out = 25
         },
         {
            orientation = "N",
            tile_opened= "02",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 30,
            cell_in = 30,
            cell_out = 23
         }
      }
   },
   W =  
   {
      position = "W",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {5,6,7,12,13,14,19,20,21,26,27,28,33,34,35,40,41,42,47,48,49},
      walls = {
         {},
         {
            tile= {"10","11"},
            positions = {5,12,19,26,33,40,47}
         }
      },
      doors = {
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 12,
            cell_in = 12,
            cell_out = 11
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 26,
            cell_in = 26,
            cell_out = 25
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 40,
            cell_in = 40,
            cell_out = 39
         }
      }
   },
   E =  
   {
      position = "E",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {1,2,3,8,9,10,15,16,17,22,23,24,29,30,31,36,37,38,43,44,45},
      walls = {
         {},
         {
            tile= {"10","11"},
            positions = {4,11,18,25,32,39,46}
         }
      },
      doors = {
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 11,
            cell_in = 10,
            cell_out = 11
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 25,
            cell_in = 24,
            cell_out = 25
         },
         {
            orientation = "E",
            tile_opened= "12",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 39,
            cell_in = 38,
            cell_out = 39
         }
      }
   },
   C =  
   {
      position = "C",
      opened = false,
      unlocked = false,
      lighted = false,
      tiles = {17,18,19,24,25,26,31,32,33},
      walls = {
         {
            tile= "09",
            positions = {17,18,19}
         },
         {
            tile= "19",
            positions = {17,24,31}
         },
         {
            tile= "09",
            positions = {38,39,40}
         },
         {
            tile= "19",
            positions = {20,27,34}
         }
      },
      doors = {
         {
            orientation = "N",
            tile_opened= "20",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 18,
            cell_in = 18,
            cell_out = 11
         },
         {
            orientation = "N",
            tile_opened= "20",
            tile_closed= "03",
            tile_unlocked= "04",
            position = 39,
            cell_in = 32,
            cell_out = 39
         },
         {
            orientation = "E",
            tile_opened= "30",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 27,
            cell_in = 26,
            cell_out = 27
         },
         {
            orientation = "E",
            tile_opened= "30",
            tile_closed= "13",
            tile_unlocked= "14",
            position = 24,
            cell_in = 24,
            cell_out = 23
         }
      }
   }
}
return cells