local helper = {}
helper.debug = ""
helper.command = ""
helper.console = false
helper.mode = 'prod'
helper.keylog = {}
helper.keylog_length = 4

function helper.draw()
	love.graphics.setFont(interface.font_log)
	love.graphics.printf(helper.debug..helper.command, 10, 150,300)
end

function helper.add_message(var,x,y,duration,color)
	message = {
		text = var,
		x = x,
		y = y,
		expiration = interface.dt+duration,
		color = color
	}
	if not var then
		message.var = ""
	end
	table.insert(interface.messages,message)
end

function helper.log(text, array)
	if helper.mode == 'dev' then
		if array ~= nil then
			for k,v in pairs(array) do
				text = text.." "..tostring(v)
			end
		end
		helper.debug = helper.debug.."\r\n"..tostring(text)
	end
end

function helper.logkey(key)
	if #helper.keylog>=helper.keylog_length then
		table.remove(helper.keylog,1)
	end
	table.insert(helper.keylog,key)
	helper.check_code(helper.serialize(helper.keylog,""))
end

function helper.alert(text, array)
	helper.mode = 'dev'
	helper.debug = ''
	helper.log("###################")
	helper.log(text, array)
	helper.log("###################")
end
function helper.in_array(haystack,needle)
	for _, val in pairs( haystack ) do 
		if needle == val then
			return true
		end
	end
	return false
end

function helper.count_occurrences(haystack,needle)
	local occurrences = 0
	for _, val in pairs( haystack ) do 
		if needle == val then
			occurrences = occurrences+1
		end
	end
	return occurrences
end

function helper.merge_tables(table1,table2)
	merged = {}
	for _, val in pairs( table1 ) do 
		table.insert(merged,val)
	end
	for _, val in pairs( table2 ) do 
		table.insert(merged,val)
	end
	return merged
end

function helper.removeTableValue(vartable, varval)
	for _, val in pairs( vartable ) do 
		if val==varval then
			table.remove(vartable,_)
		end
	end
	return vartable
end

function helper.removeByIndex(array,index)
	local trueindex = index
	for array_index, val in pairs( array ) do 
		if val.index and val.index == index then
			trueindex = array_index
		end
	end
	table.remove(array,trueindex)
end

function helper.index_of(array, value)
    for i, v in ipairs(array) do
        if v == value then
            return i
        end
    end
    return nil
end

function helper.add_to_table(vartable, varval)
	if not helper.in_array(vartable, varval) then
		table.insert(vartable, varval)
	end
end

function helper.dump(var)
	 if type(var) == 'table' then
			local s = '{ '
			for k,v in pairs(var) do
				 if type(k) ~= 'string' then k = '"'..k..'"' end
				 s = s .. '['..k..'] = ' .. helper.dump(v) .. ','
			end
			return s .. '} '
	 else
			tiles.logtext = tostring(var)
			return tostring(var)
	 end
end

function helper.serialize(var,sep)
	 if sep == nil then
        sep = ","
    end
	if type(var) == 'table' then
			local s = ""
			for k,v in pairs(var) do
				if lang[v] then
					v = lang[v]
				end
				 s = s..tostring(v)
				 if k<#var then
				 	s = s..sep
				 end
			end
			return s
	 else
			return tostring(var)
	 end
end

function helper.explode (inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end

-- console
function helper.start_console()
	helper.console = true
	helper.debug = ""
end
function helper.close_console()
	helper.console = false
	helper.debug = ""
	helper.command = ""
end
function helper.run_console()
	helper.debug = helper.debug..helper.command.."\r\n"
	local command = helper.explode(helper.command," ")
	local func = command[1]
	local var = nil
	local val = nil
	if command[2] then
		var = command[2]
		helper.debug = helper.debug.."var : "..var.."\r\n"
	else
		helper.debug = helper.debug.."var is nil\r\n"
	end
	if command[3] then
		val = command[3]
	end
	helper.command = "";
	if func == "teleport" and var then
		rooms.current_room_location.x = tonumber(string.sub(var,1,1))
		rooms.current_room_location.y = tonumber(string.sub(var,2))	
		actions.exit_room(tiles.player_direction,true)
	elseif func == "level" and var then -- pourquoi var est nil ?
		print("Func level : "..var)
		levels.current_level = var
		actions.startlevel()
	elseif func == "log" then 
			var = load("return "..var)()
			if type(var)=="string" or type(var)=="number" then
				helper.debug = helper.debug..var.."\r\n"
			else
				helper.debug = helper.debug..type(var).."\r\n"
			end
	elseif func == "set" then 
			varval = load("return "..var)()
			if type(varval)=="string" or type(varval)=="number" then
				load(var.."="..val)()
				helper.debug = helper.debug..var.." : "..val.."\r\n"
			else
				helper.debug = helper.debug..type(var).."\r\n"
			end
	elseif func == "finditem" and var and val then
			val2 = (val:gsub("^%l", string.upper))
			local items = rooms.find_item("items",var,val,"room")
			local items2 = rooms.find_item("items",var,val2,"room")
			helper.debug = helper.debug..var.." "..val.." : "..helper.serialize(items)..helper.serialize(items2).."\r\n"
	end
end

function helper.check_code(command)
	if command == "juju" then
		rooms.level.special_items.player.tile = "09"
		interface.title_level.text = "Joyeux anniversaire !!!"
	end
end

return helper