local interface = {}
interface.messages = {}
interface.cards = {}
interface.pending_inventory_card = nil
interface.alert_icons = {}
interface.dt = 0

function interface.init()
	if love.graphics.getWidth()>=1920 then
  		interface.image_dir = "1920x1080"
  		interface.top_margin = 10
  		interface.key_position_x = 600
  		interface.key_margin_x = 40
  		interface.gold_position_x = 750
		interface.inventory_card_tileset_width = 1000
		interface.inventory_card_tileset_height = 300
		interface.inventory_card_spell_tileset_height = 450
		interface.inventory_card_width= 100	
		interface.inventory_card_height= 150
		interface.inventory_card_offset_x = 10
		interface.inventory_card_spell_offset_x = 10
		interface.inventory_card_offset_y = 124
		interface.inventory_card_margin_x = 10
		interface.font_cardtitle_mini = love.graphics.newFont("fonts/BuryCaps.otf", 14)
		interface.orb_margin_x = 10
		interface.buttons_y = 80
		interface.buttons_margin_x = 2
		interface.buttons_width = 56 
		interface.skills_interface_text_y = 200	
		interface.skills_interface_textaccess_y = 800
		interface.skills_interface_button_y = 860
		interface.title_spell_x = 10
		interface.level_title_y= 20
  	else
  		interface.image_dir = "1200x780"
  		interface.top_margin = 6
  		interface.key_position_x = 380
  		interface.key_margin_x = 20  		
  		interface.gold_position_x = 460
		interface.inventory_card_tileset_width = 700
		interface.inventory_card_tileset_height = 210
		interface.inventory_card_spell_tileset_height = 315
		interface.inventory_card_width= 70
		interface.inventory_card_height= 105
		interface.inventory_card_offset_x = 10
		interface.inventory_card_spell_offset_x = 10
		interface.inventory_card_offset_y = 70
		interface.inventory_card_margin_x = 6
		interface.font_cardtitle_mini = love.graphics.newFont("fonts/BuryCaps.otf", 9)
		interface.orb_margin_x = 0
		interface.buttons_y = 80
		interface.buttons_margin_x = 2
		interface.buttons_width = 56 
		interface.skills_interface_text_y = 150
		interface.skills_interface_textaccess_y = love.graphics.getHeight()/2+240
		interface.skills_interface_button_y = interface.skills_interface_textaccess_y+60
		interface.title_spell_x = 10
		interface.level_title_y= 20
  	end
  	-- Mobile
  	mobile = false
	if love.system.getOS() == 'iOS' or love.system.getOS() == 'Android' then
		interface.mobile = true
	end
  	-- Fonts
	interface.font_default = love.graphics.newFont("fonts/AveriaSerif-Regular.ttf", 18)
	interface.font_medium = love.graphics.newFont("fonts/AveriaSerif-Regular.ttf", 14)
	interface.font_small = love.graphics.newFont("fonts/AveriaSerif-Regular.ttf", 12)
	interface.font_huge = love.graphics.newFont("fonts/AveriaSerif-Regular.ttf", 32)
	interface.font_cardtitle = love.graphics.newFont("fonts/BuryCaps.otf", 42)
	interface.font_carddesc = love.graphics.newFont("fonts/AveriaSerif-Regular.ttf", 24)
	interface.font_log = love.graphics.newFont(12)
	interface.font_button = love.graphics.newFont("fonts/AveriaSerif-Regular.ttf", 28)
	interface.font_defaultcolor = {0.64,0.62,0.5,1}
	interface.font_lightgrey = {0.8,0.8,0.8,1}
	interface.font_grey = {0.5,0.5,0.5,1}
	interface.font_yellow = {0.6,0.6,0.4,1}
	interface.font_dark = {0.15,0.12,0.1,1}
	interface.font_darkred = {0.33,0.12,0,1}
	interface.font_hover = {0.9,0.9,0.7,1}
	interface.font_alertcolor = {0.65,0.18,0.1,1}
	-- Transition background
	local current_level = 1
	if levels then
		current_level = levels.current_level
	end
	interface.image_transition = love.graphics.newImage( "images/"..interface.image_dir.."/backgrounds/transition_background_"..current_level..".png" )
	-- Home
	interface.image_home = love.graphics.newImage( "images/"..interface.image_dir.."/home_background.png" )
	-- Cursors
	interface.cursor_default = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_1.png", 10, 1 )
	interface.cursor_attack = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_2.png", 10, 10 )
	interface.cursor_wait = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_3.png", 10, 10 )
	interface.cursor_exit = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_4.png", 10, 10 )
	interface.cursor_move = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_5.png", 29, 10 )
	interface.cursor_pick = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_6.png", 10, 10 )
	interface.cursor_key = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_7.png", 10, 10 )
	interface.cursor_hand = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_8.png", 10, 10 )
	interface.cursor_out = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_9.png", 10, 10 )
	interface.cursor_lockpick = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_10.png", 10, 10 )
	interface.cursor_mech = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_11.png", 10, 10 )
	interface.cursor_teleport = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_12.png", 10, 10 )
	interface.cursor_busy = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_13.png", 10, 10 )
	interface.cursor_bolt = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_14.png", 10, 10 )
	interface.cursor_magicopen = love.mouse.newCursor( "images/"..interface.image_dir.."/cursor_15.png", 10, 10 )
	-- Tiles over
	interface.tile_color_default = {1, 1, 0.5, 1}
	interface.tile_color_danger = {1, 0.2, 0.2, 1}
	-- Spells and equipment titles
	interface.title_spells = {
		text = lang.interface_title_spells,
		font = interface.font_button,
		color = interface.font_grey
	}
	interface.title_equipment = {
		text = lang.interface_title_equipment,
		font = interface.font_button,
		color = interface.font_grey,
		x = love.graphics.getWidth() - interface.inventory_card_spell_offset_x
	}
	-- Level title
	interface.title_level = {
		text = '',
		font = interface.font_medium,
		color = interface.font_grey,
		text_position_x = love.graphics.getWidth()/2,
		text_position_y = interface.level_title_y
	}
	-- Cards
	interface.image_card_items = {
		image = love.graphics.newImage( "images/"..interface.image_dir.."/card_items.png" ),
		width= 3200,
		height = 960
	}		
	interface.image_card_slot = love.graphics.newImage( "images/"..interface.image_dir.."/interface_card_slot.png" )
	interface.image_card_items_inventory = love.graphics.newImage( "images/"..interface.image_dir.."/card_items_inventory.png" )
	interface.card_tileset_width = 3200
	interface.card_tileset_height = 960
	interface.card_width= 320
	interface.card_height= 480
	interface.card_margin_x = 10
	-- Skills cards
	interface.image_card_skills = {
		image = love.graphics.newImage( "images/"..interface.image_dir.."/card_skills.png" ),
		width= 3200,
		height = 1440
	}
	-- Spells cards	
	interface.image_card_spells_inventory = love.graphics.newImage( "images/"..interface.image_dir.."/card_spells_inventory.png" )
	interface.image_card_spells = {
		image = love.graphics.newImage( "images/"..interface.image_dir.."/card_spells.png" ),
		width= 3200,
		height = 1440
	}
	-- Skills interface
	interface.skills_interface = {
		visible = false, 
		text = "", 
		access_text = "",
		text_position_x = love.graphics.getWidth()/2,
		text_position_y = interface.skills_interface_text_y,
		text_font = interface.font_huge,
		text_color = interface.font_defaultcolor,
		textaccess_position_y = interface.skills_interface_textaccess_y,
		textaccess_font = interface.font_carddesc,
		confirm_button = {
			visible = false,
			font = interface.font_button,
			x = love.graphics.getWidth()/2,
			y = interface.skills_interface_button_y,
			width = interface.card_width, 
			height = 60,
			text = lang.interface_skills_confirm,
			action = nil,
			target = nil
		}
	}
	interface.skills_interface.confirm_button.x = interface.skills_interface.confirm_button.x - interface.skills_interface.confirm_button.width/2
	-- Background
	interface.image_interface = love.graphics.newImage( "images/"..interface.image_dir.."/interface.png" )
	interface.image_background = love.graphics.newImage( "images/"..interface.image_dir.."/room_background.png" )
	interface.image_bg_topleft = love.graphics.newImage( "images/"..interface.image_dir.."/interface_top-left.png" )
	interface.image_bg_topright = love.graphics.newImage( "images/"..interface.image_dir.."/interface_top-right.png" )
	interface.image_bg_bottomleft = love.graphics.newImage( "images/"..interface.image_dir.."/interface_bottom-left.png" )
	interface.image_bg_bottomright = love.graphics.newImage( "images/"..interface.image_dir.."/interface_bottom-right.png" )	
	-- Logo
	interface.image_logo = love.graphics.newImage( "images/"..interface.image_dir.."/interface_krol.png" )
	-- Interface Buttons
	interface.buttons =
	{
		menu = {
			image = 
			{ 
				default = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_menu.png" ),
				hover = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_menu_hover.png" ),
				active = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_menu_active.png" )
			},
			x = love.graphics.getWidth()-interface.buttons_width-interface.buttons_margin_x,
			y = interface.buttons_y,
			width = interface.buttons_width,
			height = interface.buttons_width,
			state = 'default',
			prevstate = 'default'
		},
		wait = {
			image = 
			{ 
				default = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_wait.png" ),
				hover = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_wait_hover.png" ),
				active = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_wait_active.png" )
			},
			x = love.graphics.getWidth()-interface.buttons_width*2-interface.buttons_margin_x*2,
			y = interface.buttons_y,
			width = interface.buttons_width,
			height = interface.buttons_width,
			state = 'default',
			prevstate = 'default'
		},
		map = {
			image = 
			{ 
				default = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_map.png" ),
				hover = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_map_hover.png" ),
				active = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_map_active.png" )
			},
			x = love.graphics.getWidth()-interface.buttons_width*3-interface.buttons_margin_x*3,
			y = interface.buttons_y,
			width = interface.buttons_width,
			height = interface.buttons_width,
			state = 'default',
			prevstate = 'default'
		},
		sheet = {
			image = 
			{ 
				default = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_sheet.png" ),
				hover = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_sheet_hover.png" ),
				active = love.graphics.newImage( "images/"..interface.image_dir.."/interface_button_sheet_active.png" )
			},
			x = love.graphics.getWidth()-interface.buttons_width*4-interface.buttons_margin_x*4,
			y = interface.buttons_y,
			width = interface.buttons_width,
			height = interface.buttons_width,
			state = 'default',
			prevstate = 'default'
		}
	}		
	-- Alert Icons
	interface.icon_tileset = love.graphics.newImage( "images/"..interface.image_dir.."/interface.png" )
	interface.icon_tileset_width = 1600
	interface.icon_tileset_height = 800
	interface.icon_width = 160
	interface.icon_height = 80
	interface.icon_x = love.graphics.getWidth()/2 - interface.icon_width/2
	interface.icon_y = interface.icon_height/2
	interface.icon_tiles = 
	{
		fail = "30",
		cellkey = "31",
		chestkey = "32",
		gold = "33",
		player_wounded = "34",
		player_dead = "35",
		missed = "36",
		npc_wounded = "37",
		npc_dead = "38",
		mechanism_step = "39",
		mechanism_end = "49",
		poisoned="40"
	}
	-- Vars Icons
	interface.image_cellkey = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_cellkey.png" ),
		x = interface.key_position_x,
		y = interface.top_margin/2
	}
	interface.text_cellkey = {
		font = interface.font_default,
		color = interface.font_defaultcolor,
		x = interface.image_cellkey.x + interface.image_cellkey.image:getWidth(),
		y = interface.image_cellkey.y + interface.image_cellkey.image:getHeight()/3
	}
	interface.image_chestkey = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_chestkey.png" ),
		x = interface.image_cellkey.x + interface.image_cellkey.image:getWidth() + interface.key_margin_x,
		y = interface.top_margin/2
	}
	interface.text_chestkey = {
		font = interface.font_default,
		color = interface.font_defaultcolor,
		x = interface.image_chestkey.x + interface.image_chestkey.image:getWidth(),
		y = interface.image_chestkey.y + interface.image_chestkey.image:getHeight()/3
	}
	interface.image_gold = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_gold.png" ),
		x = love.graphics.getWidth() - interface.gold_position_x,
		y = interface.top_margin
	}
	interface.text_gold = {
		font = interface.font_default,
		color = interface.font_defaultcolor,
		x = interface.image_gold.x + interface.image_gold.image:getWidth() + 3,
		y = interface.image_gold.y + interface.image_gold.image:getHeight()/4
	}
	interface.image_combat = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_combat.png" ),
		x = interface.text_gold.x + interface.key_margin_x,
		y = interface.top_margin/2
	}
	interface.text_combat = {
		font = interface.font_default,
		color = interface.font_defaultcolor,
		x = interface.image_combat.x + interface.image_combat.image:getWidth(),
		y = interface.text_gold.y
	}	
	interface.text_combat_modifier = {
		font = interface.font_medium,
		color = interface.font_alertcolor,
		x = interface.text_combat.x + 10,
		y = interface.text_combat.y + 2
	}
	interface.image_health = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_health.png" ),
		image_empty = love.graphics.newImage( "images/"..interface.image_dir.."/interface_health_empty.png" ),
		x = 20,
		y = interface.top_margin,
		xstep = 20
	}		
	interface.image_movement = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_movement.png" ),
		image_empty = love.graphics.newImage( "images/"..interface.image_dir.."/interface_movement_empty.png" ),
		x = 20,
		y = interface.top_margin+5,
		xstep = 2,
		ystep = 2
	}	
	interface.image_mana = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_mana.png" ),
		image_empty = love.graphics.newImage( "images/"..interface.image_dir.."/interface_mana_empty.png" ),
		x = love.graphics.getWidth()-20,
		y = interface.top_margin,
		xstep = 20
	}
	interface.image_orb = { 
		image = love.graphics.newImage( "images/"..interface.image_dir.."/interface_orb.png" ),
		x = interface.image_cellkey.x + interface.image_cellkey.image:getWidth(),
		y = interface.top_margin+30,
		xstep = interface.orb_margin_x
	}
	-- compass
	interface.compass = {
		image_background = love.graphics.newImage( "images/"..interface.image_dir.."/interface_compass_bg.png" ),
		image_cursor = love.graphics.newImage( "images/"..interface.image_dir.."/interface_compass_cursor.png" ),
		image_found = love.graphics.newImage( "images/"..interface.image_dir.."/interface_compass_found.png" ),
		image_cursor_main = love.graphics.newImage( "images/"..interface.image_dir.."/interface_compass_cursor_main.png" ),
		image_found_main = love.graphics.newImage( "images/"..interface.image_dir.."/interface_compass_found_main.png" ),
		x = love.graphics.getWidth()-50,
		y = interface.top_margin+150,
		angle = nil,
		room = nil,
		tile = nil,
		door = nil,
		visible = false,
		direction = nil
	}
	-- vars
	interface.messages = {}
	interface.cards = {}
	interface.alert_icons = {}
	interface.delays = {health = nil, mana = nil}
	-- shader test
	interface.brightness_shader = love.graphics.newShader([[
		extern number brightness;

		vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords)
		{
			vec4 texcolor = Texel(texture, texture_coords);
			vec4 result = vec4(texcolor.rgb * (brightness+0.4), texcolor.a);
			return result * color;
		}
	]])
	-- inventory slots
	if tiles then
		interface.inventory_slots = {}
		for i=1,tiles.player.max_items do		
			local slot = {
				size = 1,
				cards = {}
			}
			table.insert(interface.inventory_slots,slot)
		end
	end
end

function interface.draw()
	-- level title
	love.graphics.printf({interface.title_level.color,interface.title_level.text},interface.title_level.font,0, interface.title_level.text_position_y,love.graphics.getWidth(),'center')
	-- black background
	love.graphics.draw(transition.background, 1, 1)	
	-- sheet
	if sheet.visible then
		love.graphics.draw(sheet.canvas, sheet.x, sheet.y)
	end	
	-- map
	if map.visible then
		love.graphics.draw(map.canvas, map.x, map.y)
	end
	love.graphics.setShader()
	 -- GUI
	love.graphics.setColor( 1,1,1,1)
	love.graphics.setShader(interface.brightness_shader)	
    interface.brightness_shader:send("brightness", config.brightness)
	love.graphics.draw( interface.image_bg_topleft, 0, 0, 0, 1, 1, 0, 0)
	love.graphics.draw( interface.image_bg_topright, love.graphics.getWidth(), 0, 0, 1, 1, interface.image_bg_topright:getWidth(), 0)
	love.graphics.draw( interface.image_bg_bottomleft, 0, love.graphics.getHeight(), 0, 1, 1, 0, interface.image_bg_bottomleft:getHeight())
	love.graphics.draw( interface.image_bg_bottomright, love.graphics.getWidth(), love.graphics.getHeight(), 0, 1, 1, interface.image_bg_bottomright:getWidth(), interface.image_bg_bottomright:getHeight())
	love.graphics.setColor( 1,1,1,1 )
	love.graphics.draw( interface.image_cellkey.image , interface.image_cellkey.x, interface.image_cellkey.y)
	love.graphics.print( {interface.text_cellkey.color, tiles.player.cellkeys}, interface.text_cellkey.font, interface.text_cellkey.x, interface.text_cellkey.y)
	love.graphics.draw( interface.image_chestkey.image , interface.image_chestkey.x, interface.image_chestkey.y)
	love.graphics.print( {interface.text_chestkey.color, tiles.player.chestkeys}, interface.text_chestkey.font, interface.text_chestkey.x, interface.text_chestkey.y)
	love.graphics.draw( interface.image_gold.image , interface.image_gold.x, interface.image_gold.y)
	love.graphics.print( {interface.text_gold.color, tiles.player.gold}, interface.text_gold.font, interface.text_gold.x, interface.text_gold.y)
	love.graphics.draw( interface.image_combat.image , interface.image_combat.x, interface.image_combat.y)
	love.graphics.print( {interface.text_combat.color, tiles.player.combat}, interface.text_combat.font, interface.text_combat.x, interface.text_combat.y)
	local combat_modifier = player.modifiers.combat + player.item_modifiers.combat
	if player.current_health == 1 then
		combat_modifier = combat_modifier - 1
	end
	if combat_modifier ~= 0 then
		if combat_modifier>0 then
			combat_modifier = "+"..combat_modifier
		end
		love.graphics.print( {interface.text_combat_modifier.color, combat_modifier}, interface.text_combat_modifier.font, interface.text_combat_modifier.x, interface.text_combat_modifier.y)
	end
	-- Logo
	if #player.spells==0 then
		love.graphics.draw( interface.image_logo , 0, love.graphics.getHeight()-interface.image_logo:getHeight())
	end
	-- Buttons
	for button_name,button in pairs(interface.buttons) do
		love.graphics.draw( button.image[button.state] , button.x, button.y, 0, 0.75, 0.75 )
	end
	-- Health
	posx = interface.image_health.x
	for i=1,tiles.player.health do
		if i<= tiles.player.current_health then
			love.graphics.draw( interface.image_health.image , posx, interface.image_health.y)
		else
			love.graphics.draw( interface.image_health.image_empty , posx, interface.image_health.y)
		end		
		if interface.delays.health and interface.delays.health<100 and i == tiles.player.current_health+1 then
			love.graphics.printf({interface.font_defaultcolor,interface.delays.health.."%"},posx,interface.image_health.y+interface.image_health.image:getHeight()/2-10,interface.image_health.image:getWidth(),'center')
		end
		posx = posx + interface.image_health.image:getWidth() + interface.image_health.xstep
	end	
	-- Movement
	posx = interface.image_movement.x
	posy = interface.image_health.y + interface.image_health.image:getHeight() + interface.image_movement.y
	odd = true
	for i=1,tiles.player.movement+player.modifiers.movement+tiles.player.item_modifiers.movement do
		odd = not odd
		if i<= tiles.player_movement then
			love.graphics.draw( interface.image_movement.image , posx, posy)
		else
			love.graphics.draw( interface.image_movement.image_empty , posx, posy)
		end
		posx = posx + interface.image_movement.image:getWidth()/2 + interface.image_movement.xstep
		if odd then
			posy = posy + interface.image_movement.image:getHeight()/2 + interface.image_movement.xstep
		else
			posy = posy - interface.image_movement.image:getHeight()/2 - interface.image_movement.xstep
		end
	end
	-- Mana
	posx = interface.image_mana.x-interface.image_mana.image:getWidth()
	for i=1,tiles.player.mana do
		if i<= tiles.player.current_mana then
			love.graphics.draw( interface.image_mana.image , posx, interface.image_mana.y)
		else
			love.graphics.draw( interface.image_mana.image_empty , posx, interface.image_mana.y)
		end
		if interface.delays.mana and interface.delays.mana<100 and i == tiles.player.current_mana+1 then
			love.graphics.printf({interface.font_defaultcolor,interface.delays.mana.."%"},posx,interface.image_health.y+interface.image_mana.image:getHeight()/2-5,interface.image_mana.image:getWidth(),'center')
		end
		posx = posx - interface.image_mana.image:getWidth() - interface.image_health.xstep
	end	
	-- Orbs
	posx = interface.image_orb.x-interface.image_orb.image:getWidth()
	for i=1,player.orbs do
			love.graphics.draw( interface.image_orb.image , posx, interface.image_orb.y)
			posx = posx + interface.image_orb.image:getWidth() + interface.image_orb.xstep
	end
	-- message
	for message_index,message in pairs(interface.messages) do
		local time_left = message.expiration - interface.dt
		if time_left>0 then
			if message.color then
				if message.color == "green" then
					love.graphics.setColor(0.5, 1, 0.5, time_left)	
				elseif message.color == "red" then
					love.graphics.setColor(1, 0.2, 0.2, time_left)
				elseif message.color == "purple" then
					love.graphics.setColor(0.6, 0, 0.6, time_left)
				elseif message.color == "yellow" then
					love.graphics.setColor(1, 1, 0.5, time_left)
				end
			else
				love.graphics.setColor(1, 1, 1, time_left)
			end
			if message.text then
				love.graphics.printf(message.text,message.x, message.y+time_left*50,300)
			else
				helper.alert("[interface.lua ligne 507] Texte du message non trouvé. Message : "..helper.dump(message))
			end
		else
			table.remove(interface.messages,message_index)
		end
	end
	-- icons
	for icon_index,icon in pairs(interface.alert_icons) do
		if icon.expiration > interface.dt and icon.start < interface.dt then
			love.graphics.setColor(1, 1, 1, 1)
			love.graphics.draw( icon.sprite.image_tile,	icon.sprite.quad, interface.icon_x, interface.icon_y)
		elseif icon.expiration < interface.dt then
			table.remove(interface.alert_icons,icon_index)
		end
	end
	-- compass
	if interface.compass.visible then
		local cwidth = interface.compass.image_background:getWidth()
		local cheight = interface.compass.image_background:getHeight()
		local img_found = interface.compass.image_found
		local img_cursor = interface.compass.image_cursor
		if interface.compass.cursor then
			img_found = interface.compass['image_found_'..interface.compass.cursor]
			img_cursor = interface.compass['image_cursor_'..interface.compass.cursor]
		end
		love.graphics.draw( interface.compass.image_background , interface.compass.x-interface.compass.image_background:getWidth(), interface.compass.y)
		if interface.compass.angle == nil then
			love.graphics.draw( img_found , interface.compass.x-interface.compass.image_background:getWidth(), interface.compass.y)
		else
			love.graphics.draw( img_cursor , interface.compass.x-cwidth/2, interface.compass.y+cheight/2,interface.compass.angle,1,1,cwidth/2,cheight/2)
		end
	end
	-- cards
	local start_y =  love.graphics.getHeight()/2 - interface.card_height/2
	local count = 1	
	for card_index,card in pairs(interface.cards) do		
		local start_x = love.graphics.getWidth()/2 - interface.card_width/2
		if #interface.cards==2 then
			if count == 1 then
				start_x = love.graphics.getWidth()/2 - interface.card_width - interface.card_margin_x/2
			else
				start_x = love.graphics.getWidth()/2 + interface.card_margin_x/2
			end
		elseif #interface.cards==3 and count ~= 2 then
			if count == 1 then
				start_x = start_x - interface.card_width - interface.card_margin_x
			else
				start_x = start_x + interface.card_width + interface.card_margin_x
			end
		elseif #interface.cards==4 then
			start_x = love.graphics.getWidth()/2 - interface.card_width*2 - interface.card_margin_x - interface.card_margin_x/2
			if count>1 then
				start_x = start_x + (count-1)*(interface.card_width+interface.card_margin_x)
			end
		end
		-- background
		card.sprite.x = start_x
		card.sprite.y = start_y
		love.graphics.setColor(1, 1, 1, 1)
		love.graphics.draw( card.sprite.image_tile,	card.sprite.quad, card.sprite.x, card.sprite.y )
		-- title
		love.graphics.setFont(interface.font_cardtitle)
		local card_title = lang[card.name]
		love.graphics.printf({interface.font_darkred,card_title},start_x,start_y,interface.card_width,'center')
		-- description
		love.graphics.setFont(interface.font_carddesc)
		local card_desc = lang[card.desc]
		local desc_y = start_y+265
		if card.desc_y then
			desc_y = start_y+card.desc_y
		end
		love.graphics.printf({interface.font_dark,card_desc},start_x,desc_y,interface.card_width,'center')
		if card.shadowed then
			love.graphics.setColor(0, 0, 0, 0.8)
			love.graphics.rectangle('fill', card.sprite.x, card.sprite.y, interface.card_width, interface.card_height)
			love.graphics.setColor(interface.font_lightgrey)
		end
		count = count+1
	end
	-- inventory cards
	start_x = love.graphics.getWidth() - interface.inventory_card_offset_x
	start_y =  love.graphics.getHeight() - interface.image_bg_bottomright:getHeight() + interface.inventory_card_offset_y	
	---- inventory slots
	for i=1,tiles.player.max_items do
		local slot_start_x = start_x - (i*(interface.inventory_card_width+interface.inventory_card_margin_x)) - 1
		love.graphics.draw( interface.image_card_slot , slot_start_x,start_y-1)
	end
	local cards_count = 1
	for slot_index,slot in pairs(interface.inventory_slots) do
		if #slot.cards > 0 then
			local icard = tiles.player.items[slot.cards[1]]	
			icard.sprite.x = start_x - (cards_count*(interface.inventory_card_width+interface.inventory_card_margin_x))
			icard.sprite.y = start_y
			icard.sprite.width = interface.inventory_card_width
			icard.sprite.height = interface.inventory_card_height
			love.graphics.setColor(1, 1, 1, 1)
			love.graphics.draw(icard.sprite.image_tile, icard.sprite.quad, icard.sprite.x, icard.sprite.y )
			-- title
			love.graphics.setFont(interface.font_cardtitle_mini)
			local card_title = lang[icard.name]
			love.graphics.printf({interface.font_darkred, card_title},icard.sprite.x,icard.sprite.y,interface.inventory_card_width,'center')
			if #slot.cards>1 then
				love.graphics.setFont(interface.font_medium)
				love.graphics.printf({interface.font_darkred, "("..#slot.cards..")"},icard.sprite.x,icard.sprite.y +70,interface.inventory_card_width,'center')
			end
			cards_count = cards_count + 1
		end
	end
	love.graphics.setColor(1, 1, 1, 1)
	love.graphics.setFont(interface.title_equipment.font)
	love.graphics.printf({interface.title_equipment.color,interface.title_equipment.text},interface.title_equipment.x-500,start_y-40,500,'right')
	-- spell cards
	start_x = interface.inventory_card_spell_offset_x
	start_y =  love.graphics.getHeight() - interface.image_bg_bottomright:getHeight() + interface.inventory_card_offset_y
	cards_count = 0
	if #player.spells>0 then
		--love.graphics.printf({interface.font_darkred,interface.title_spells.text},start_x,start_y-20,1000,'left')
		love.graphics.setColor(1, 1, 1, 1)
		love.graphics.print( {interface.title_spells.color,interface.title_spells.text}, interface.title_spells.font, start_x, start_y-40)
	end
	for card_index,icard in pairs(player.spells) do
		icard.index = card_index
		icard.sprite.x = start_x + (cards_count*(interface.inventory_card_width+interface.inventory_card_margin_x))
		icard.sprite.y = start_y
		icard.sprite.width = interface.inventory_card_width
		icard.sprite.height = interface.inventory_card_height
		love.graphics.setColor(1, 1, 1, 1)
		love.graphics.draw(icard.sprite.image_tile, icard.sprite.quad, icard.sprite.x, icard.sprite.y )
		-- title
		love.graphics.setFont(interface.font_cardtitle_mini)
		local card_title = lang[icard.name]
		love.graphics.printf({interface.font_darkred, card_title},icard.sprite.x,icard.sprite.y,interface.inventory_card_width,'center')
		-- darken tile if not usable
		icard.enabled = true
		if player.current_mana < icard.effect.cost then
			love.graphics.setColor(0, 0, 0, 0.5)
			love.graphics.rectangle('fill',icard.sprite.x,icard.sprite.y,interface.inventory_card_width,interface.inventory_card_height)
			love.graphics.setColor(1, 1, 1, 1)
			icard.enabled = false
		end
		for mod_index,mod in pairs(effects.modifiers) do
			if mod.spell and mod.spell==icard.name then
				local ratio = mod.current_duration/mod.duration
				local progress_height = interface.inventory_card_height*ratio
				local progress_y = icard.sprite.y+interface.inventory_card_height-progress_height
				love.graphics.setColor(0, 0, 0, 0.5)
				love.graphics.rectangle('fill',icard.sprite.x,progress_y,interface.inventory_card_width,progress_height)
				love.graphics.setColor(1, 1, 1, 1)
				icard.enabled = false
			end
		end
		cards_count = cards_count + 1
	end
	-- hover button
	if interface.square_button ~= nil then		
		love.graphics.setColor(0, 0, 0, 0.5)
		love.graphics.setFont(interface.square_button.font)
		love.graphics.rectangle('fill', interface.square_button.x, interface.square_button.y, interface.square_button.width, interface.square_button.height)
		local xcenter = interface.square_button.x
		local ycenter = interface.square_button.y + interface.square_button.height/2 - 10
		love.graphics.setColor(interface.font_lightgrey)
		if interface.square_button.select_y then
			 ycenter = interface.square_button.y+interface.square_button.select_y
		end
		love.graphics.printf(interface.square_button.text,xcenter, ycenter,interface.square_button.width,'center')
	end	
	-- menu
	if menu.visible then
		local start_x = love.graphics.getWidth()/2 -menu.current_params.width/2
		local start_y =  love.graphics.getHeight()/2 - menu.current_params.height/2
		love.graphics.draw(menu.canvas,start_x,start_y)
	end
	-- skills interface
	if interface.skills_interface.visible and interface.skills_interface.text then
		love.graphics.setColor(interface.skills_interface.text_color)
		love.graphics.setFont(interface.skills_interface.text_font)
		love.graphics.printf(interface.skills_interface.text,0, interface.skills_interface.text_position_y,love.graphics.getWidth(),'center')
		if interface.skills_interface.confirm_button.visible then
			local button = interface.skills_interface.confirm_button
			if button.hover then
				love.graphics.setColor(255, 255, 255, 0.1)
			else
				love.graphics.setColor(255, 255, 255, 0.2)
			end
			love.graphics.rectangle('fill', button.x, button.y, button.width, button.height)
			if button.hover then
				love.graphics.setColor(255, 255, 255, 0.2)
				love.graphics.rectangle('line', button.x, button.y, button.width, button.height)
			end
			love.graphics.setColor(interface.skills_interface.text_color)
			love.graphics.printf(button.text,button.x, button.y+button.height/5,button.width,'center')
		end
		love.graphics.setFont(interface.skills_interface.textaccess_font)
		love.graphics.printf(interface.skills_interface.access_text,0, interface.skills_interface.textaccess_position_y,love.graphics.getWidth(),'center')
	end
end

function interface.update(dt)
	interface.dt = interface.dt+dt
	if sheet.sliding == "in" then
		if sheet.x < sheet.x_in then
			sheet.x = sheet.x + (sheet.x_in-sheet.x_out)/20
		end
	elseif sheet.sliding == "out" then
		if sheet.x > sheet.x_out then
			sheet.x = sheet.x - (sheet.x_in-sheet.x_out)/20
		else
			sheet.visible = false
		end
	end
	if map.sliding == "in" then
		if map.x > map.x_in then
			map.x = map.x - (map.x_out-map.x_in)/20
		end
	elseif map.sliding == "out" then
		if map.x < map.x_out then
			map.x = map.x + (map.x_out-map.x_in)/20
		else
			map.visible = false
		end
	end
	if transition.fading == "in" or transition.fading == "in-out" then
      if transition.background_alpha<1 then
         transition.background_alpha = transition.background_alpha + transition.fading_step
         transition.draw_background()
      elseif  transition.fading == "in-out" then
         transition.next_function.func(transition.next_function.args)
         transition.fading = "out"
      else
         transition.fading = false
      end
   	elseif transition.fading == "out" then
      if transition.background_alpha>0 then
         transition.background_alpha = transition.background_alpha - transition.fading_step
         transition.draw_background()
      else
         transition.fading = false
      end
   	end
end

function interface.sort_cards()
	-- reset slots
	interface.inventory_slots = {}
	for i=1,tiles.player.max_items do		
		local slot = {
			size = 1,
			cards = {}
		}
		table.insert(interface.inventory_slots,slot)
	end
	-- sort cards
	for card_index,icard in ipairs(tiles.player.items) do
		icard.index = card_index
		for slot_index,slot in ipairs(interface.inventory_slots) do
			if #slot.cards == 0 or (#slot.cards < slot.size and icard.type == 'scroll') then
				icard.slot_index = slot_index
				table.insert(slot.cards,icard.index)
				if icard.type == 'scroll' then
					slot.size = 4
				end
				break
			end
		end
	end
end

function interface.can_insert(icard)
	for slot_index,slot in pairs(interface.inventory_slots) do
		if #slot.cards == 0 or (#slot.cards < slot.size and icard.type == 'scroll') then
			return true
		end
	end
	return false
end

function interface.add_card(card,tileset)
	local new_card
	if card.subtype == "spells" then
		new_card =  
		{
	         type= card.type,
	         subtype= card.subtype,
	         name= card.name,
	         id= card.id,
	         desc= card.desc,
	         tile= card.tile,
	         effect = card.effect,
	         sprite = interface.new_sprite(interface.card_width, interface.card_height, card.tile, tileset.image, tileset.width, tileset.height)
      	}
		table.insert(interface.cards,new_card)
	else
		card.sprite = interface.new_sprite(interface.card_width, interface.card_height, card.tile, tileset.image, tileset.width, tileset.height)
		table.insert(interface.cards,card)
	end
end

function interface.new_sprite(width, height, tiletype, tileset, tileset_width, tileset_height)
	 return( {
			 width = width,
			 height = height,
			 tiletype = tiletype,
			 image_tile = tileset,
			 quad = interface.tiletype_to_quad( tiletype, width, height, tileset_width, tileset_height )} )
end

function interface.tiletype_to_quad( tiletype, width, height, tileset_width, tileset_height )
	 if tiletype == nil then
			return nil
	 end
	 local row = math.floor( tiletype / 10 )
	 local col = tiletype % 10
	 local x_pos = width * ( col ) 
	 local y_pos = height * ( row )
	 return love.graphics.newQuad( x_pos, y_pos,width, height, tileset_width, tileset_height)
end

function interface.show_icon(icon_tile)
	local icon = {}
	if #interface.alert_icons > 0 then
		local last_icon = interface.alert_icons[#interface.alert_icons]
		icon.start = last_icon.expiration
		icon.expiration = last_icon.expiration+1/(#interface.alert_icons+1)
	else
		icon.start = interface.dt
		icon.expiration = interface.dt+1
	end
	icon.sprite = interface.new_sprite(interface.icon_width, interface.icon_height, icon_tile, interface.icon_tileset, interface.icon_tileset_width, interface.icon_tileset_height)
	table.insert(interface.alert_icons,icon)
end

function interface.show_skills_interface(skill_type)
	interface.skills_interface.visible = true
	interface.skills_interface.text = lang["interface_skills_text_"..skill_type]
end

function interface.hide_skills_interface()
	interface.skills_interface.visible = false
	interface.skills_interface.text = ""
end

function interface.init_compass(room,tile,door,cursor)
	interface.compass.room = room
	interface.compass.tile = tile
	interface.compass.door = door
	interface.compass.cursor = cursor
	interface.compass.visible = true
end

function interface.update_compass()
	if interface.compass.visible then
		helper.log("cx"..interface.compass.room.x.."cy"..interface.compass.room.y)
		if rooms.current_room_location.x == interface.compass.room.x and rooms.current_room_location.y == interface.compass.room.y then
			interface.compass.angle = nil
		else
			local dist_x =  rooms.current_room_location.x - interface.compass.room.x
			local dist_y = rooms.current_room_location.y - interface.compass.room.y
			interface.compass.angle = math.atan2 ( interface.compass.room.y- rooms.current_room_location.y, interface.compass.room.x - rooms.current_room_location.x)
		end
	end
end

function interface.setCursor(cursor)
	if not interface.mobile then
		love.mouse.setCursor(cursor)
	end
end

return interface