local level = {}
level.size = {
   height = 3,
   width = 3
}
level.start_type = "edge"
level.start_position = "center"
level.start_room = {}
level.player_start_position = nil
level.entrance = {tiles={NS="08",WE="18"},player_position="center"}
level.tilesets = {
   floor = "image_floor",
   wall = "image_wall",
   items = "image_items",
   npcs = "image_creatures"
}
level.music = "game2.ogg"
level.cell_model = "outdoor"
level.cell_open_ratio = 1
level.cell_lock_level = 1
level.items_count = 3
level.min_npcs = 1
level.max_npcs = 4
level.num_layers = 4
level.theme = "ruins"
level.reset = {
   player = {}
}
level.skills = {"paths","attributes"}
level.events = {
   create_room = {
      {
         state = 'pending',
         main = true,
         count = {min=5,max=9},
         targets = {
            create = {
               items = { "pit" },
               boss = { "worg" },
               cells = {cells = {C = true}, open_ratio = 0},
               active = {items = true, boss = true, cells = true, message = true},
               message = "hint_level1_pit"
            }
         }
      },
      {
         state = 'pending',
         count = {min=2,max=3},
         main = true,
         targets = {
            create = {
               items = { "barrel" },
               active = {items = true}
            }
         }
      }
   }
}
level.objectives = {
   starttext = "level_start_1",
   endtext = "level_end_1"
}
level.conditions = {
   items = {
      {
         attr = 'min_cellkey',
         val = 1,
         min = 1
      },
      {
         attr = 'type',
         val = 'Pit',
         min = 1
      }
   },
   npcs = {
      {
         attr = 'type',
         val = 'Worg',
         min = 1
      }
   }
}
level.tile_items = {
   { 
      type="Decor",
      tile= {"12","13"},
      solid=true,
      layer=3,
      count=24,
      placeable = "hall",
      action=false
   },
   { 
      type="Decor",
      tile= "14",
      solid=true,
      layer=3,
      count=48,
      placeable = "cell",
      action=false
   },
   { 
      type="Decor",
      tile= "15",
      solid=true,
      layer=3,
      count=12,
      placeable = "cell",
      action=false
   },
   { 
      type="Barrel",
      subtype="Barrel",
      tile="07",
      tile_opened="17",
      max_gold=3,
      max_cellkey=0,
      max_chestkey=0,
      max_items=0,
      solid=true,
      layer=3,
      count=8,
      action="pick"
   },
   { 
      type="Barrel",
      subtype="Crate",
      tile="08",
      tile_opened="18",
      max_gold=1,
      max_cellkey=0,
      max_chestkey=0,
      max_items=0,
      solid=true,
      layer=3,
      count=80,
      action="pick"
   },
   { 
      type="Barrel",
      subtype="Crate",
      tile="09",
      tile_opened="19",
      max_gold=1,
      max_cellkey=0,
      max_chestkey=0,
      max_items=1,
      solid=true,
      layer=3,
      count=24,
      action="pick"
   }
}
level.special_items = {
   player =
   { 
      type="Player",
      tile="00",
      tileset="image_player",
      solid=true,
      placeable = "all",
      layer=3,
   },
   purse =
   { 
      type="Purse",
      tile="20",
      solid=false,
      layer=2,
      booty={},      
      placeable = "all",
      action="pick"
   },
   halo =
   { 
      type="Halo",
      tile="21",
      tileset="image_items",
      solid="npcs",      
      placeable = "cell",
      layer=4
   },
   bolt =
   { 
      type="Bolt",
      tile="23",
      tileset="image_items",
      solid="npcs",      
      placeable = "cell",
      layer=4
   },
   pit =
   { 
      type="Pit",
      tile="22",
      tileset="image_items",
      placeable = "cell",
      solid="npcs",
      action="victory",
      layer=1,
      position=25
   },
   barrel =
   { 
      type="Barrel",
      subtype="Barrel",
      tile="07",
      tile_opened="17",
      max_gold=0,
      min_cellkey=1,
      max_cellkey=1,
      max_chestkey=0,
      max_items=0,
      solid=true,
      layer=3,
      action="pick"
   }
}
level.tile_npcs = {
   { 
      type="Rat",
      tile="04",
      solid=true,
      speed=5,
      health=1,
      attack=1,
      defense=2,
      count=24,
      max_gold=0,
      max_chestkey=0,
      max_cellkey=0,
      max_items=0,
      layer=3,
      placeable = "all",
      hostility = 1,
      vigilance = 3
   }
}
level.boss = {
   worg = { 
      type="Worg",
      tile="06",
      solid=true,
      speed=6,
      health=3,
      attack=2,
      defense=2,
      count=1,
      max_gold=0,
      max_chestkey=0,
      max_cellkey=0,
      max_items=0,
      layer=3,
      placeable = "hall",
      hostility = 2,
      vigilance = 10
   }
}
level.card_items = {
   { 
      type="potion",
      subtype="Health",
      name="card_title_health",
      desc="card_desc_health",
      tile="00",
      amount=1,
      value=8,
      uses=1,
      count=4,
      modifier = {type="unique",property="health",amount=1,duration=0}
   },
   { 
      type="potion",
      subtype="Combat",
      name="card_title_combat",
      desc="card_desc_combat",
      tile="01",
      value=8,
      uses=1,
      count=4,
      modifier = {type="timed",property="combat",amount=1,duration=10,max=0}
   },
   { 
      type="torch",
      subtype="Torch",
      name="card_title_torch",
      desc="card_desc_torch",
      tile="14",
      value=4,
      uses=0,
      count=8,
      modifier = {type="equip",property="vision",amount=2,max=1}
   }--[[,
   { 
      type="potion",
      subtype="Mana",
      name="card_title_mana",
      desc="card_desc_mana",
      tile="02",
      amount=1,
      value=8,
      uses=1,
      count=0,
      duration=0
   },
   { 
      type="potion",
      subtype="Speed",
      name="card_title_speed",
      desc="card_desc_speed",
      tile="03",
      amount=2,
      value=8,
      uses=1,
      count=20,
      duration=10
   }
   ,
   { 
      type="orb",
      subtype="Green",
      name="card_title_greenorb",
      desc="card_desc_orb",
      tile="10",
      amount=1,
      value=8,
      uses=1,
      count=5,
      duration=0
   }]]
}
return level