local menu = {}

menu.visible = false
menu.sound_hover = love.audio.newSource("sounds/hover.wav","static")
menu.sound_hover:setVolume(config.sound_volume)
menu.current_items = {}
menu.setting_buttons = {}

menu.items = {
   home = {
      {text="menu_play",action={task = "start"},hover=false},
      {text="menu_load",action={task = "load"},hover=false},
      {text="menu_options",action={task = "showmenu",menu="homeoptions"},hover=false},
      {text="menu_credits",action={task = "showmenu",menu="credits"},hover=false},
      {text="menu_quitgame",action={task = "showmenu",menu="quitgame"},hover=false}
   },
   game =
   {
      {text="menu_continue",action={task = "continue"},hover=false},
      {text="menu_restart",action={task = "load"},hover=false},
      {text="menu_options",action={task = "showmenu",menu="gameoptions"},hover=false},
      {text="menu_quitlevel",action={task = "showmenu",menu="quitlevel"},hover=false}
   },
   quitgame =
   {
      {text="menutitle_quitgame",action={task = nil},hover=false},
      {text="menu_cancel",action={task = "showmenu",menu="home"},hover=false},
      {text="menu_confirm",action={task = "exit"},hover=false}
   },
   quitlevel =
   {
      {text="menutitle_quitlevel",action={task = nil},hover=false},
      {text="menu_cancel",action={task = "showmenu", menu="game"},hover=false},
      {text="menu_confirm",action={task = "home"},hover=false}
   },
   homeoptions =
   {
      {text="menutitle_options",action={task = nil},hover=false},
      {text="menutitle_language",action={task = "langmenu", state = "home"},hover=false},
      {text="menutitle_sound",action={task = "showmenu", menu="soundoptions"},hover=false},
      {text="menutitle_brightness",action={task = "showmenu", menu="brightnessoptions"},hover=false},
      {text="menu_back",action={task = "showmenu",menu="home"},hover=false}
   },
   gameoptions =
   {
      {text="menutitle_options",action={task = nil},hover=false},
      {text="menutitle_language",action={task = "langmenu", state = "game"},hover=false},
      {text="menutitle_sound",action={task = "showmenu", menu="gamesoundoptions"},hover=false},
      {text="menutitle_brightness",action={task = "showmenu", menu="gamebrightnessoptions"},hover=false},
      {text="menu_back",action={task = "showmenu", menu="game"},hover=false}
   },
   soundoptions =
   {
      {text="menutitle_sound_volume",action={task = nil},hover=false},
      {text="",action={task = "setting",prop="sound_volume",min=0,max=10},hover=false},
      {text="menutitle_music_volume",action={task = nil},hover=false},
      {text="",action={task = "setting",prop="music_volume",min=0,max=10},hover=false},      
      {text="menu_back",action={task = "showmenu", menu="homeoptions"},hover=false}
   },
   brightnessoptions =
   {
      {text="menutitle_brightness",action={task = nil},hover=false},
      {text="",action={task = "setting",prop="brightness",min=0,max=10},hover=false},     
      {text="menu_back",action={task = "showmenu", menu="homeoptions"},hover=false}
   },
   gamesoundoptions =
   {
      {text="menutitle_sound_volume",action={task = nil},hover=false},
      {text="",action={task = "setting",prop="sound_volume",min=0,max=10},hover=false},
      {text="menutitle_music_volume",action={task = nil},hover=false},
      {text="",action={task = "setting",prop="music_volume",min=0,max=10},hover=false},      
      {text="menu_back",action={task = "showmenu", menu="gameoptions"},hover=false}
   },
   gamebrightnessoptions =
   {
      {text="menutitle_brightness",action={task = nil},hover=false},
      {text="",action={task = "setting",prop="brightness",min=0,max=10},hover=false},     
      {text="menu_back",action={task = "showmenu", menu="gameoptions"},hover=false}
   },
   credits =
   {
      {text="menutitle_credits",action={task = nil},hover=false},
      {text="menudesc_credits",action={task = nil},hover=false},
      {text="menu_back",action={task = "showmenu", menu="home"},hover=false}
   }
}

menu.params = {
   home = {
      font = interface.font_huge,
      background = {0, 0, 0, 0},
      width = 520,
      height = 400,
      margin = 0
   },
   credits = {
      font = interface.font_huge,
      background = {0, 0, 0, 0},
      width = 800,
      height = 700,
      margin = 0
   },
   homeoptions = {
      font = interface.font_huge,
      background = {0, 0, 0, 0},
      width = 300,
      height = 300,
      margin = 0
   },
   game = {
      font = interface.font_default,
      background = {0, 0, 0, 0.8},
      width = 462,
      height = 288,
      margin = 40
   },
   intro = {
      font = interface.font_carddesc,
      background = {0, 0, 0, 0},
      width = 800,
      height = 700,
      margin = 0
   }
}

function menu.init(state)
   menu.state = state
   menu.prev_hover = 0
   menu.canvas = love.graphics.newCanvas(menu.width, menu.height)
   menu.current_items = {}
   for index,item in pairs (menu.items[state]) do
      newitem = {}
      for k,v in pairs (item) do
         newitem[k] = v
      end
      table.insert( menu.current_items,newitem)
   end
   for index,item in pairs(menu.current_items) do 
      item.text = lang[item.text]
   end
   if menu.params[state] ~=nil then
      menu.current_params = menu.params[state]
   end
   menu.drawmenu()
end

function menu.showmenu()
   if menu.visible then
      menu.visible = false
      interface.buttons.menu.state = "default"
   else
      menu.visible = true
      interface.buttons.menu.state = "active"
   end
   interface.buttons.menu.prevstate = interface.buttons.menu.state
end

function menu.drawmenu()
   menu.setting_buttons = {}
   love.graphics.setCanvas(menu.canvas)
   love.graphics.clear()
   love.graphics.setBlendMode("alpha")  
   -- background
   if menu.type == "box" then
      love.graphics.setColor(menu.current_params.background)
      love.graphics.rectangle('fill', 0, 0, menu.current_params.width, menu.current_params.height)  
   end
   -- texts
   love.graphics.setColor(interface.font_lightgrey)
   local itemheight = (menu.current_params.height-menu.current_params.margin*2)/#menu.current_items
   local itemwidth = menu.current_params.width
   local xcenter = 0
   local ycenter = menu.current_params.margin + itemheight/2
   for k,item in ipairs(menu.current_items) do 
      local fontcolor = nil
      if not item.action.task then
         fontcolor = interface.font_lightgrey
      else
         if item.hover then
            fontcolor = interface.font_hover
            if k~=menu.prev_hover then
               love.audio.play(menu.sound_hover)
               menu.prev_hover = k
            end
         else
            fontcolor = interface.font_yellow
         end
      end
      item.x = xcenter
      item.y = ycenter
      item.width = itemwidth
      item.height = itemheight      
      if item.action and item.action.task == "setting" then
         local square_width = itemwidth/11 - 2
         local square_height = itemheight/2 - 2
         square_x = 0
         square_y = item.y
         local button_color
         local prop_value = tonumber(config[item.action.prop])
         --love.graphics.printf({fontcolor,prop_value}, menu.current_params.font, xcenter, ycenter,itemwidth,'center')
         for x=0,10 do
            if x/10<=prop_value then
               button_color = {0.7, 0.7, 0.2, 0.8}
            else
               button_color = {0.3, 0.3, 0.1, 0.8}
            end
            menu.addSettingButton(square_x,square_y,square_width,square_height,button_color,item.action.prop,x/10)
            square_x = square_x + square_width + 2
         end
         love.graphics.setColor(1, 1, 1, 1)
      else
         love.graphics.printf({fontcolor,item.text}, menu.current_params.font, xcenter, ycenter,itemwidth,'center')
      end
      ycenter = ycenter + itemheight
   end
   love.graphics.setCanvas()
end

function menu.addSettingButton(x,y,width,height,color,prop,value)
   love.graphics.setColor(color)
   love.graphics.rectangle('fill', x, y, width, height)
   local button = {
      x = x, 
      y = y, 
      width = width, 
      height = height,
      prop = prop,
      value = value
   }
   table.insert(menu.setting_buttons,button)
end

function menu.action(action,prop,value)
   menu.visible = false
   if action.task == "start" then
      love.audio.stop(menu.music)
      gamestates.set_state( "game", { current_room = 1, loadgame = false } )
   elseif action.task == "load" then
      love.audio.stop(menu.music)
      gamestates.set_state( "game", { current_room = 1, loadgame = true } )   
   elseif action.task == "continue" then
      --
   elseif action.task == "home" then 
      -- brutal restart
      love.event.quit("restart")
      -- todo instead ?     
      gamestates.set_state( "home" )
      menu.init('home')
      menu.visible = true
   elseif action.task == "showmenu" then
      menu.init(action.menu)
      menu.drawmenu()
      menu.visible = true   
   elseif action.task == "langmenu" then
      menu.current_items = menu.langmenu(action.state)
      menu.drawmenu()
      menu.visible = true
   elseif action.task == "soundmenu" then
      menu.current_items = menu.soundmenu(action.state)
      menu.drawmenu()
      menu.visible = true
   elseif action.task == "setlang" then
      config.lang = action.lang
      local data = binser.serialize(config)
      love.filesystem.write("conf",data)
      lang.init (action.lang)
      menu.init(action.state)
      menu.drawmenu()
      menu.visible = true
   elseif action.task == "startlevel" then
      actions.startlevel()
   elseif action.task ==  "newturn" then
      actions.newturn(player,true)
      menu.init('game')
   elseif action.task == "exit" then
      love.event.quit()   
   elseif action.task == "hint" then
      menu.init('game') 
   elseif action.task == "skills" then
      menu.escapable = true
      menu.has_background = true
      menu.init("game") 
      actions.select_skills()   
   elseif action.task == "setting" then
      config[prop] = value
      local data = binser.serialize(config)
      love.filesystem.write("conf",data)
      if prop == "music_volume" then
         if menu.state == "gamesoundoptions" then
            sounds.update_music_volume()
         else
            menu.update_music_volume()            
         end
      elseif prop == "sound_volume" then
         menu.sound_hover:setVolume(config.sound_volume)
      elseif prop == "brightness" then
         brightness_shader:send("brightness", config.brightness)
      end
      menu.visible = true
   else
      menu.visible = true
   end
   if menu.visible then
      interface.buttons.menu.state = "active"
      interface.buttons.menu.prevstate = "active"
   else
      interface.buttons.menu.state = "default"
      interface.buttons.menu.prevstate = "default"
   end
end

function menu.langmenu(state)
   local langmenu = {}
   local row = {text=lang.menutitle_language,action={task = nil},hover=false}
   table.insert(langmenu,row)
   for code,language in pairs(lang.langs) do 
      local row = {text=language.text,action={task = "setlang", lang=code, state=state},hover=false}
      table.insert(langmenu,row)
   end
   return langmenu
end

function menu.alertmenu(text,buttontext,action,menutype)
   local alertmenu = {}
   local textrow = {text=lang[text],action={task = nil},hover=false}
   table.insert(alertmenu,textrow)
   local buttonrow = {text=lang[buttontext],action={task = action},hover=false}
   table.insert(alertmenu,buttonrow)
   menu.current_items = alertmenu
   if menutype == "intro" then
      menu.type = "intro"
      menu.escapable = false
      menu.current_params = menu.params.intro
   else
      menu.type = "box"
      menu.escapable = true
      menu.current_params = menu.params.game
   end
   menu.drawmenu()
   menu.visible = true
end

function menu.update_music_volume()
   -- sounds.game_music:setVolume(config.music_volume)
   menu.music:setVolume(config.music_volume)
end

return menu