local luastar = require("helpers/lua-star")
local path = {}

function path.drawPath(level_tiles,test,start,dest,unwalkable,pop)
		tiles.path = {}
		local current_path = {}
		local directions = {}
		local walkable
		if start == nil then
			start = tiles.current_player_position
		end
		if dest == nil then
			dest = tiles.tile_clicked
		end
		if unwalkable == nil then
			unwalkable = {}
		end
		local target
		if pop ~= nil then
			target = dest
		else
			target = nil
		end
		if start~=dest and dest~=nil and dest>0 then
			x = 0
			local current_cell = rooms.get_cell_from_position(start,tiles.current_room)
			next_cell = rooms.get_cell_from_position(dest,tiles.current_room)
			-- pourquoi est-ce nécessaire ?
			if current_cell>0 and start == tiles.current_room.cells[current_cell].door.cell_out then
				cell = 0
				helper.removeTableValue(tiles.walkable,start)
			end
			current_path = {}
			-- same cell/hall
			if current_cell == next_cell then
				if current_cell == 0 then
					walkable = tiles.current_room.hall.tiles
				else
					walkable = tiles.current_room.cells[current_cell].tiles
				end
				current_path = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(start), path.get_coordinates(dest), path.is_vacant_callback, walkable, unwalkable, target)		
			-- hall to cell
			elseif current_cell == 0 then				
				    walkable = tiles.current_room.hall.tiles
					local step1 = tiles.current_room.cells[next_cell].door.cell_out
					local step2 = tiles.current_room.cells[next_cell].door.cell_in
					local cell_out_is_vacant = path.is_vacant(step1,unwalkable) or step1 == start
					local cell_in_is_vacant = path.is_vacant(step2,unwalkable) or (step2 == dest and pop ~= nil)
				if cell_out_is_vacant and cell_in_is_vacant then
					local path1 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(start), path.get_coordinates(step1), path.is_vacant_callback, walkable, unwalkable, target)
					walkable = tiles.current_room.cells[next_cell].tiles
					local path2 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(step2), path.get_coordinates(dest), path.is_vacant_callback, walkable, unwalkable, target)
					if path1 and path2 then
						current_path = helper.merge_tables(path1,path2)
					else
						current_path = nil
					end
				else
					current_path = nil
				end
			-- cell to hall
			elseif next_cell == 0 then
				walkable = tiles.current_room.cells[current_cell].tiles
				local step1 = tiles.current_room.cells[current_cell].door.cell_in
				local step2 = tiles.current_room.cells[current_cell].door.cell_out
				local cell_in_is_vacant = path.is_vacant(step1,unwalkable) or step1 == start
				local cell_out_is_vacant = path.is_vacant(step2,unwalkable) or (step2 == dest and pop ~= nil)
				if cell_out_is_vacant and cell_in_is_vacant then
					local path1 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(start), path.get_coordinates(step1), path.is_vacant_callback, walkable, unwalkable, target)
					walkable = tiles.current_room.hall.tiles
					local path2 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(step2), path.get_coordinates(dest), path.is_vacant_callback, walkable, unwalkable, target)
					if path1 and path2 then
						current_path = helper.merge_tables(path1,path2)
					else
						current_path = nil
					end
				else
					current_path = nil
				end
			-- cell to cell
			else
				walkable = tiles.current_room.cells[current_cell].tiles
				local step1 = tiles.current_room.cells[current_cell].door.cell_in
				local step2 = tiles.current_room.cells[current_cell].door.cell_out
				local step3 = tiles.current_room.cells[next_cell].door.cell_out
				local step4 = tiles.current_room.cells[next_cell].door.cell_in
				local cell_in_is_vacant = path.is_vacant(step1,unwalkable) or step1 == start
				local cell_out_is_vacant = path.is_vacant(step2,unwalkable)
				local cell_out_is_vacant2 = path.is_vacant(step3,unwalkable)
				local cell_in_is_vacant2 = path.is_vacant(step4,unwalkable) or (step4 == dest and pop ~= nil)
				if cell_out_is_vacant and cell_in_is_vacant and cell_out_is_vacant2 and cell_in_is_vacant2 then
					local path1 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(start), path.get_coordinates(step1), path.is_vacant_callback, walkable, unwalkable, target)
					walkable = tiles.current_room.hall.tiles
					local path2 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(step2), path.get_coordinates(step3), path.is_vacant_callback, walkable, unwalkable, target)
					walkable = tiles.current_room.cells[next_cell].tiles
					local path3 = luastar:find(tiles.columns, tiles.rows, path.get_coordinates(step4), path.get_coordinates(dest), path.is_vacant_callback, walkable, unwalkable, target)
					if path1 and path2 and path3 then
						local path_a = helper.merge_tables(path1,path2)
						current_path = helper.merge_tables(path_a,path3)
					else
						current_path = nil
					end
				else
					current_path = nil
				end
			end
			if current_path then
				if #current_path>1 and pop == true then
					table.remove(current_path)
				end
				directions = {
					N_N = 0, S_S = 0,
					E_E = 1, W_W = 1,
					SW_SW = 2, NE_NE = 2,
					SE_SE = 3, NW_NW = 3,
					E_A = 4,
					N_A = 5,
					W_A = 6,
					S_A = 7,
					NE_A = 8,
					SW_A = 9,
					NW_A = 10,
					SE_A = 11,
					S_SW = 12,
					NE_N = 12,
					W_SW = 13, NE_E = 13,
					E_NE = 14, SW_W = 14,
					SW_S = 15, N_NE = 15,
					S_SE = 16, NW_N = 16, 
					E_SE = 17, NW_W = 17,
					SE_E = 18, W_NW = 18,
					SE_S = 19, N_NW = 19,
					NE_NW = 20, SE_SW = 20,
					NW_NE = 21, SW_SE = 21,
					NE_SE = 22, NW_SW = 22,
					SE_NE = 23, SW_NW = 23,
					N_W = 24, E_S = 24,
					N_E = 25, W_S = 25,
					S_E = 26, W_N = 26,
					S_W = 27, E_N = 27

				}
				-- Set directions
				for path_index, step in pairs( current_path ) do 
					x = x + 1
					if x== 1 then				
						step.direction = path.get_direction(path.get_coordinates(start),step)
					else
						step.direction = path.get_direction(current_path[x-1],step)
					end
					step.position = tiles.get_tile_from_coords(step.x,step.y)
				end

				x = 0
				for path_index, step in pairs( current_path ) do 
					
					x = x + 1
					
					local direction = step.direction
					if x == #current_path then
						direction = direction.."_A"
					else
						direction = direction.."_".. current_path[x+1].direction
					end

					path_tile = directions[direction]				
					if path_tile == nil then
						path_tile = 29
						-- print("Tile manquante : "..direction)
					end

					local sprite_tile = level_tiles[step.position]
					local new_sprite_position = {x=sprite_tile.position.x,y=sprite_tile.position.y}
					local new_sprite = tiles.new_tile( new_sprite_position,tiles.tile_width,tiles.tile_height,path_tile,tiles.image_interface,1)
					local tile_items = tiles.get_tile_items(step.position) 
					local is_trap = false
					for i,item in pairs(tile_items.items) do
						if item.type == "Trap" and item.state == nil and helper.in_array(player.skills.abilities,"TRAPDETECTION") then
							is_trap = true
						end
					end
					if x > tiles.player_movement+1 then
						new_sprite.rgb = {0.2,0,0}
					elseif tiles.player_movement>=#current_path and actions.current_action == "attack" and player.charge and #current_path>actions.charge_threshold then
						new_sprite.rgb = {0.5,0.3,0}
					elseif is_trap then
						new_sprite.rgb = {1,0.2,0.2}
					end
					if not test then
						path.add_to_path( new_sprite, step.position )
					end
				end
				if test then
					return current_path
				else
					tiles.next_player_movement = current_path
					player.last_movement = current_path
				end
			else
				if test then
					return {}
				else
					tiles.next_player_movement = {}
				end
			end
		end 
end

function path.add_to_path( sprite, tile_index )
	 if tiles.path[tile_index] == nil then
			tiles.path[tile_index] = {}
	 end
	 table.insert( tiles.path[tile_index], sprite )
end

function path.is_vacant(tile_index, unwalkable,check_solid)
	if unwalkable == nil then
		unwalkable = {}
	end
	if check_solid == nil then
		check_solid = true
	end
	if tile_index == tiles.current_player_position then
		return false
	end
	if helper.in_array(unwalkable,tile_index) then
		return false
	end
	if tile_index<1 or tile_index>tiles.rows*tiles.columns then
		return false
	end
	for position, layer in pairs( tiles.sprites ) do 
		for layer_index, sprite in pairs(layer ) do 
			local solid
		    if tile_index == position then
		    	if sprite.solid == "npcs" then
		    		if tiles.turn == "npcs" then
		    			solid = true
		    		else
		    			solid = false
		    		end
		    	else
		    		solid = sprite.solid
		    	end
		    	if not check_solid or solid then
		   			return false
		   		end
		   	end
		end
	end
	return true
end

function path.is_vacant_callback(x,y,walkable,unwalkable,check_sprites,target)
	tile_index = tiles.get_tile_from_coords(x,y)
	if check_sprites==nil then
		check_sprites = true
	end
	if tile_index == target then
		check_sprites = false
	end
	if not helper.in_array(walkable,tile_index) then
		return false
	end
	if helper.in_array(unwalkable,tile_index) then
		return false
	end
	if check_sprites then
		local solid
		for position, layer in pairs( tiles.sprites) do 
			for layer_index, sprite in pairs(layer ) do 
				if sprite.solid == "npcs" then
					if tiles.turn == "npcs" then
		    			solid = true
		    		else
		    			solid = false
		    		end
		    	else
		    		solid = sprite.solid
		    	end
			    if tile_index == position and solid then
			   		return false
			   	end
			end
		end
	end
	return true
end

function path.get_adjacent(tile_index,vacant_check,cell_check,include_doors)

	 if include_doors == nil then
	 	include_doors = false
	 end
	 local tiles_walkable = {}
	 local adjacent = {}
	 local center_tile = path.get_coordinates(tile_index)	 
	 local all_tiles = {
	 	{x=center_tile.x,y=center_tile.y-1}, --N
	 	{x=center_tile.x-1,y=center_tile.y}, --E	 	
	 	{x=center_tile.x,y=center_tile.y+1}, -- S
	 	{x=center_tile.x+1,y=center_tile.y}, -- W
	 	{x=center_tile.x-1,y=center_tile.y-1}, --NE
	 	{x=center_tile.x-1,y=center_tile.y+1}, -- SE
	 	{x=center_tile.x+1,y=center_tile.y+1}, -- SW
	 	{x=center_tile.x+1,y=center_tile.y-1}, -- NW
	 }
	 if cell_check then	
	 	-- check hall
	 	for _, tile in pairs( tiles.current_room.hall.tiles ) do 
	 		if tile_index == tile then
	 			for _, t in pairs( tiles.current_room.hall.tiles ) do 
	 				table.insert(tiles_walkable,t)
	 			end
	 			for _, cell in ipairs( tiles.current_room.cells ) do 
		 			if cell.door.cell_out == tile then
		 				if include_doors and current_player_position ~= cell.door.cell_in  and not helper.in_array(tiles_walkable,cell.door.cell_in) then
							table.insert(tiles_walkable,cell.door.cell_in)
						end
					end
				end
	 		end
	 	end
	 	-- check cells
	 	for _, cell in ipairs( tiles.current_room.cells ) do 
	 		for _, tile in pairs( cell.tiles ) do 
	 			if tile_index == tile then
	 				for _, t in pairs( cell.tiles ) do 
	 					table.insert(tiles_walkable,t)
	 				end
					if include_doors and current_player_position ~= cell.door.cell_out and not helper.in_array(tiles_walkable,cell.door.cell_out) then
						-- désactivé bloque joueur dans certains cas ?
						table.insert(tiles_walkable,cell.door.cell_out)
					end
				end
			end
		end
	 end
	 for _, tile in ipairs( all_tiles ) do 
	 	if tile.x > 0 and tile.x <= tiles.columns and tile.y >0 and tile.y <= tiles.rows then
		 	tile_index = tiles.get_tile_from_coords(tile.x,tile.y)
		 	if cell_check then	
		 		if path.is_vacant_callback(tile.x,tile.y,tiles_walkable,{},vacant_check) then
		 			table.insert(adjacent, tile_index)
		 		end 		
		 	elseif vacant_check then
		 		if path.is_vacant(tile_index) then
		 			table.insert(adjacent, tile_index)
		 		end
		 	else
		 		table.insert(adjacent, tile_index)
		 	end
		 	if tile_index == tiles.current_player_position then
		 		adjacent = {}
		 		break
		 	end
		 end
	end
	return adjacent
end

function path.is_adjacent(index1,index2)
	local adjacent = path.get_adjacent(index1)
	local is_adjacent = helper.in_array(adjacent,index2)
	return is_adjacent
end

function path.get_ahead_tile(tile_index,direction,outbound)
	local source_tile = path.get_coordinates(tile_index)
	local ahead_tile = {x = source_tile.x,y=source_tile.y}
	if direction == "N" or direction == "NW" or direction == "NE" then
		if source_tile.y == 1 and not outbound then
			return false
		elseif ahead_tile.y then
			ahead_tile.y = ahead_tile.y - 1
		else
			return false
		end
	elseif direction == "S" or direction == "SW" or direction == "SE" then
		if source_tile.y == tiles.rows and not outbound then
			return false
		elseif ahead_tile.y then
			ahead_tile.y = ahead_tile.y + 1
		else
			return false
		end
	end
	if direction == "W" or direction == "NW" or direction == "SW" then
		if source_tile.x == 1 and not outbound then
			return false
		elseif ahead_tile.x then
			ahead_tile.x = ahead_tile.x + 1
		else
			return false
		end
	elseif direction == "E" or direction == "SE" or direction == "NE" then
		if source_tile.x == tiles.columns and not outbound then
			return false
		elseif ahead_tile.x then
			ahead_tile.x = ahead_tile.x - 1
		else
			return false
		end
	end
	return tiles.get_tile_from_coords(ahead_tile.x,ahead_tile.y) 
end

function path.get_random_direction()
	local directions = {"N","S","W","E","NE","NW","SW","SE"}
	local index = math.random(8)
	return directions[index]
end

function path.get_opposite_direction(direction)
	local directions1 = {"N","S","W","E","NE","NW","SW","SE"}	
	local directions2 = {"S","N","E","W","SW","SE","NE","NW"}
	local index = helper.index_of(directions1,direction)
	return directions2[index]
end

function path.get_player_direction(position)
	local direction
	if position == 1 then
		direction = "SW"
	elseif position == 7 then
		direction = "SE"
	elseif position == 43 then
		direction = "NW"
	elseif position == 49 then
		direction = "NE"
	elseif position<7 then
		direction = "S"
	elseif position % tiles.rows == 0 then
		direction = "E"
	elseif position>43 then
		direction = "N"
	elseif (position-1) % tiles.rows == 0 then
		direction = "W"
	else
		direction = path.get_random_direction()
	end
	return direction
end

function path.get_direction(start,dest)
	local direction = ""
	if start.y > dest.y then
		direction = "N"
	end
	if start.y < dest.y then
		direction = "S"
	end
	if start.x < dest.x then
		if dest.x-start.x >= math.abs(start.y-dest.y) then
			direction = direction.."W"
		end
	end
	if start.x > dest.x then
		if start.x-dest.x >= math.abs(start.y-dest.y) then
			direction = direction.."E"
		end
	end
	return direction
end

function path.get_direction_modifier(ennemy,attacker)
	local directions = {"N","NE","E","SE","S","SW","W","NW"}
	helper.log("Attaquant : "..attacker)
	if attacker == "E" then
		att_angle = helper.index_of(directions,ennemy.direction)
		def_angle = helper.index_of(directions,tiles.player_direction)
		helper.log("Dir att : "..ennemy.direction.." def : "..tiles.player_direction)
	else
		att_angle = helper.index_of(directions,tiles.player_direction)
		def_angle = helper.index_of(directions,ennemy.direction)
		helper.log("Dir att : "..tiles.player_direction.." def : "..ennemy.direction)
	end	local rel_angle = math.abs(att_angle-def_angle)
	if rel_angle>4 then
		rel_angle = 8 - rel_angle
	end
	rel_angle = 4 - rel_angle
	if rel_angle > 0 then
		rel_angle = rel_angle -1
	end
	if attacker == "E" then
		rel_angle = 0 - rel_angle
	end
	helper.log("Angle att : "..att_angle.." def : "..def_angle)	
	helper.log("Angle rel : "..rel_angle)
	return rel_angle
end

function path.in_fov(source_direction, target_direction)
	local directions = {"N","NE","E","SE","S","SW","W","NW"}
	local in_fov_directions = {source_direction}
	local source_index = helper.index_of(directions,source_direction)
	if source_index == 1 then
		table.insert(in_fov_directions, directions[#directions])
		table.insert(in_fov_directions, directions[source_index+1])
	elseif source_index == #directions then
		table.insert(in_fov_directions, directions[source_index-1])
		table.insert(in_fov_directions, directions[1])
	else
		table.insert(in_fov_directions, directions[source_index-1])
		table.insert(in_fov_directions, directions[source_index+1])
	end
	return helper.in_array(in_fov_directions,target_direction)
end

function path.get_coordinates(tile)
	local pos_x
	local pos_y
	for x = 1, tiles.rows do
		for y = 0, tiles.columns-1 do
			local index = y*tiles.columns+x;
			if index==tile then
					pos_x=x
					pos_y=y+1
			end
		end
	end
	return {x=pos_x,y=pos_y}
end

function path.is_in_same_cell(source_pos,target_pos)
	local is_target_free = true
	local is_source_free = true
	local target_cell = 0
	local source_cell = 0
	for cell_index, cell in ipairs( tiles.current_room.cells ) do
		if not cell.opened then
			for tile_index, tile in pairs(cell.tiles) do
				if tile == target_pos then
					is_target_free = false
					target_cell = cell_index
				end
				if tile == source_pos then
					is_source_free = false
					source_cell = cell_index
				end
			end
		end
	end
	if not is_source_free then
		if is_target_free then
			is_target_free = false
		elseif target_cell == source_cell then
			is_target_free = true
		end
	end
	return is_target_free
end


-- fov
function path.direction_to_angle(direction) 
	if direction == "W" then
		return 0
	elseif direction == "SW" then
		return 45
	elseif direction == "S" then
		return 90
	elseif direction == "SE" then
		return 135
	elseif direction == "E" then
		return 180
	elseif direction == "NE" then
		return 225
	elseif direction == "N" then
		return 270
	elseif direction == "NW" then
		return 315
	else
		return false
	end
end
function path.isTransparent(x,y)
	--if x<0 or y<0 or x>tiles.rows or y>tiles.columns or not x or not y then
		-- return false
	--else
		local xy = tiles.get_tile_from_coords(x,y)
		local tile_cell = rooms.get_cell_from_position(xy,tiles.current_room)
		local player_cell = rooms.get_cell_from_position(tiles.current_player_position,tiles.current_room)
		if tile_cell == player_cell then
			if tile_cell>0 then
				cell = tiles.current_room.cells[tile_cell]
				if helper.in_array(cell.inner_walls,xy) then
					-- tiles.background_tiles[xy].is_wall = true
					return false
				else
					return true
				end
			else
				return true
			end
		else
			for _, cell in ipairs( tiles.current_room.cells ) do 
	 			if cell.door.cell_out == xy or cell.door.cell_in == xy then
	 				return true
				end
			end
			if player_cell>0 then
				cell = tiles.current_room.cells[player_cell]				
				if cell and helper.in_array(cell.outer_walls,xy) then
					tiles.background_tiles[xy].is_wall = true
					return false
				end
			else
				for _, cell in ipairs( tiles.current_room.cells ) do 
		 			if helper.in_array(cell.outer_walls,xy) or helper.in_array(cell.inner_walls,xy) then
						tiles.background_tiles[xy].is_wall = true
						return false
					end
				end
			end
		end
	--end
end
function path.onVisible(x,y)
	-- invert xy
	local position = tiles.get_tile_from_coords(x,y)
	local tile = tiles.background_tiles[position]
	if tile and x>0 and x<=tiles.rows and y>0 and y<=tiles.columns and not helper.in_array(tiles.seen, position) then
		-- helper.log(x.."-"..y.."-"..position)
		table.insert(tiles.seen, position)
		tiles.background_tiles[position].visible = tiles.background_tiles[position].visible + 1
	end
end

return path