local sheet = {}
sheet.set = false
sheet.visible = false

function sheet.init()
   if not sheet.set then
      sheet.width = love.graphics.getWidth()/4
      sheet.height = love.graphics.getHeight()
      sheet.x_in = 0
      sheet.x_out = 0 - sheet.width
      sheet.x = sheet.x_out
      sheet.y = 0
      sheet.canvas = love.graphics.newCanvas(sheet.width, sheet.height)
      sheet.sliding = true
      sheet.set = true
   end
   sheet.drawsheet()
end

function sheet.showsheet()
   if sheet.visible then
      interface.buttons.sheet.state = "default"
      sheet.sliding = "out"
   else
      sheet.drawsheet()
      sheet.visible = true
      interface.buttons.sheet.state = "active"
      sheet.sliding = "in"
   end
   interface.buttons.sheet.prevstate = interface.buttons.sheet.state
end

function sheet.drawsheet()
   love.graphics.setCanvas(sheet.canvas)
   love.graphics.clear()
   love.graphics.setBlendMode("alpha")  
   -- background
   love.graphics.setColor(0.1, 0.1, 0.1, 0.6)
   love.graphics.rectangle('fill', 0, 0, sheet.width, sheet.height)
   
   local c_sheet = player.getSheet()
   local textpos = {x = 40, y = 220}
   love.graphics.setColor(1,1, 1,1)
   love.graphics.print( {interface.font_grey, lang.sheet_title}, interface.font_default, textpos.x, textpos.y)
   textpos.y = textpos.y + 60
   for i,section in ipairs(c_sheet) do
      love.graphics.print( {interface.font_defaultcolor, section.title}, interface.font_medium, textpos.x, textpos.y)
      textpos.y = textpos.y + 20
      for n,char in ipairs(section.values) do
         love.graphics.print( {interface.font_lightgrey, char.title}, interface.font_medium, textpos.x, textpos.y)
         if char.value then
            love.graphics.print( {interface.font_lightgrey, char.value}, interface.font_medium, textpos.x+240, textpos.y)
         end
         textpos.y = textpos.y + 20
      end
      textpos.y = textpos.y + 20
   end
   -- love.graphics.print( {interface.text_combat.color, "Feuille de personnage"}, interface.text_combat.font, 0, 400)
   --love.graphics.printf("Feuille de personnage",0, 200,sheet.width)

   love.graphics.setCanvas()
end

return sheet