local skills = {}
skills.level_amount = 3
skills.paths = {
   STRENGTH = {
      tile="00",
      effect = {property="combat",amount=1},
      tree = {
         CONSTITUTION = {
            "MELEE","ROBUSTNESS","CHARGE"
         },
         AGILITY = {
            "SUPPLENESS","DODGE_SA","AMBIDEXTROUS"
         },
         MENTAL = {
            "PAINCONTROL"
         },
         WISDOM = {
            "TACTICS"
         },
         GUILE = {
            "ASSASSINATION"
         }
      }
   },
   GUILE = {
      tile="01",
      effect = {property="stealth",amount=1},
      tree = {
         CONSTITUTION = {
            "BACKPACKER","MELEE"
         },
         AGILITY = {
            "LOCKPICKING","DODGE_GA","TRAPDEACTIVATION"
         },
         MENTAL = {
            "TRAPDETECTION","VIGILANCE"
         },
         WISDOM = {
            "MECHANICS"
         },
         STRENGTH = {
            "ASSASSINATION"
         }
      }
   },
   WISDOM = {
      tile="02",
      effect = {property="mana",amount=4},
      tree = {
         CONSTITUTION = {
            "HEALTHREGENERATION"
         },
         AGILITY = {
            "DODGE_WA"
         },
         MENTAL = {
            "MANAREGENERATION"
         },
         STRENGTH = {
            "TACTICS"
         },
         GUILE = {
            "MECHANICS"
         }
      },
      spells = {
         CONSTITUTION = {
            "HEALING","ARMOR"
         },
         AGILITY = {
            "SPEED","INVISIBILITY"
         },
         MENTAL = {
            "TELEPORTATION","SACRIFICE"
         },
         STRENGTH = {
            "ATTACK","COMBAT"
         },
         GUILE = {
            "OPENING","TRAPDETECTION"
         }
      }
   }
}
skills.attributes = {
   CONSTITUTION = {
      effect = {property="health",amount=1},
      tile="03"
   },
   AGILITY = {  
      effect = {property="movement",amount=1},    
      tile="04"
   },
   MENTAL = {
      effect = {property="vision",amount=1},      
      tile="05"
   }
}
skills.abilities = {
   MELEE = {
      tile="10",
      effect = {property="melee",amount=1}
   },
   ROBUSTNESS = {
      tile="11",
      effect = {property="robustness",amount=1}      
   },
   CHARGE = {
      tile="12",
      effect = {property="charge",amount=1}   
   },
   SUPPLENESS = {
      tile="13",
      effect = {property="rear_defence",amount=1}  
   },
   DODGE_SA = {
      tile="14",
      effect = {property="dodge",amount=1}  
   },
   AMBIDEXTROUS = {
      tile="15",
      effect = {property="ambidextrous",amount=1}  
   },
   PAINCONTROL = {      
      tile="16",
      effect = {property="paincontrol",amount=1}  
   },
   TACTICS = {      
      tile="17",
      effect = {property="upgrade",skills = {"MELEE","CHARGE"}, amount=1}  
   },
   ASSASSINATION = {
      tile="18",
      effect = {property="assassination",amount=1}  
   },
   VIGILANCE = {
      tile="19",
      effect = {property="rear_defence",amount=1}  
   },
   BACKPACKER = {
      tile="20",
      effect = {property="max_items",amount=1}  
   },
   LOCKPICKING = {
      tile="21",
      effect = {property="lockpicking",amount=1}  
   },
   DODGE_GA = {
      tile="22",
      effect = {property="dodge",amount=1}  
   },
   TRAPDETECTION = {
      tile="23",
      effect = {property="trap_detection",amount=1}  
   },
   TRAPDEACTIVATION = {
      tile="24",
      effect = {property="trap_deactivation",amount=1}  
   },
   HEALTHREGENERATION = {
      tile="25",
      effect = {property="health",delay="20",amount=1}  
   },
   DODGE_WA = {
      tile="26",
      effect = {property="dodge",amount=1}  
   },
   MANAREGENERATION = {
      tile="27",
      effect = {property="mana",delay="20",amount=1}  
   },
   MECHANICS = {      
      tile="28",
      effect = {property="upgrade",skills = {"LOCKPICKING","TRAPDEACTIVATION"}, amount=1}  
   }
}
skills.spells = {
   HEALING = {
      tile="0",
      effect = {type="modifier",property="current_health",amount=1,duration=0,cost=1}
   },
   ARMOR = {
      tile="1",
      effect = {type="modifier",property="robustness",amount=2,duration=20,cost=1}
   },
   SPEED = {
      tile="2",
      effect = {type="modifier",property="movement",amount=2,duration=20,cost=1}
   },
   INVISIBILITY = {
      tile="3",
      effect = {type="modifier",property="stealth",amount=5,duration=10,cost=1}
   },
   TELEPORTATION = {
      tile="4",
      effect = {type="action",action="teleport",property=nil,amount=1,duration=0,cost=1}
   },
   SACRIFICE = {
      tile="5",
      effect = {type="modifier",property="current_mana",amount=1,property_out="current_health",amount_out=1,duration=0,cost=0}
   },
   ATTACK = {
      tile="6",
      effect = {type="action",action="bolt",amount=1,duration=0,cost=1}
   },
   COMBAT = {
      tile="7",
      effect = {type="modifier",property="combat",amount=2,duration=5,cost=1},
   },
   OPENING = {
      tile="8",
      effect = {type="action",action="magicopen",amount=1,duration=0,cost=1}
   },
   TRAPDETECTION = {
      tile="9",
      effect = {type="action",action="showtraps",amount=1,duration=1,cost=0}
   }
}

function skills.get_cards(skill_type,step)
   local selected_skills = {}
   if skill_type == "abilities" then
      local abilities = skills.get_abilities()
      selected_skills = levels.shuffle(abilities)
   elseif skill_type == "spells" then
      local spells = skills.get_spells()
      selected_skills = levels.shuffle(spells)
   else
      selected_skills = levels.shuffle(skills[skill_type],true)
   end
   helper.log(skill_type.." : "..#selected_skills)
   if #selected_skills == 0 then
      helper.log("PAS DE CARTES")
      actions.select_skills(step+1)
      return
   end
   i = 1
   local prefix = "skill_"
   if skill_type == "spells" then
      prefix = "spell_"
   end
   for skill_index,skill in pairs(selected_skills) do
      if not helper.in_array(player.skills[skill_type],skill.index) then
         if i <= skills.level_amount then
            local card = {
               type = "skill",
               subtype = skill_type,
               id = skill.index,
               name = prefix..skill.index,
               desc = prefix.."desc_"..skill.index,
               tile = skill.tile,
               effect = skill.effect,
               desc_y = 350,
               select_y = 190
            }
            helper.log(card.name)
            if skill_type == "spells" then
               interface.add_card(card,interface.image_card_spells)
            else
               interface.add_card(card,interface.image_card_skills)
            end
            i = i+1
         end
      end
   end
   interface.skills_interface.next_step = step+1
   if #selected_skills>0 then
      interface.show_skills_interface(skill_type)
   end
end

function skills.apply_card(card)
   table.insert(player.skills[card.subtype],card.id)
   if card.subtype == "spells" then
      local interface_card = 
      {
         type= "spell",
         subtype= card.subtype,
         name= card.name,
         desc= card.desc,
         tile= card.tile,
         effect = card.effect,
         sprite = interface.new_sprite(interface.inventory_card_width, interface.inventory_card_height, card.tile, interface.image_card_spells_inventory, interface.inventory_card_tileset_width, interface.inventory_card_spell_tileset_height)
      }
      card.sprite = interface.new_sprite(interface.inventory_card_width, interface.inventory_card_height, card.tile, interface.image_card_spells_inventory, interface.inventory_card_tileset_width, interface.inventory_card_spell_tileset_height)
      table.insert(player.spells,interface_card)
   else
      if card.effect.property then
         if card.effect.delay then
            player.delayed_modifiers[card.effect.property] = card.effect
            player.delayed_modifiers[card.effect.property].current_delay = card.effect.delay
         elseif card.effect.property == "upgrade" then
            for k,skill in ipairs(card.effect.skills) do
               helper.log("Capacité : "..skill)
               local ability = skills.abilities[skill]
               if helper.in_array(player.skills.abilities,skill) then
                  helper.log("Upgrade joueur : "..skill.." + 1")
                  -- if ability already learned, upgrade player property
                  player[ability.effect.property] = player[ability.effect.property] + card.effect.amount
               else
                  -- else upgrade card
                  helper.log("Upgrade carte : "..skill.." + 1")
                  skills.abilities[skill].effect.amount = skills.abilities[skill].effect.amount + card.effect.amount
               end
            end
         else
            if player[card.effect.property] then
               player[card.effect.property] = player[card.effect.property] + card.effect.amount
            else
               player[card.effect.property] = card.effect.amount
            end
            if( player["current_"..card.effect.property]) then
               if player["current_"..card.effect.property] + card.effect.amount > player[card.effect.property] then
                  player["current_"..card.effect.property] = player[card.effect.property]
               else
                  player["current_"..card.effect.property] =  player["current_"..card.effect.property] + card.effect.amount
               end
            end
            if card.effect.property == "mana" then
               player.current_mana = player.mana
            end
         end
      end
   end
   sheet.drawsheet()
end

function skills.get_abilities(card)
   local abilities = {}
   if card then
      if card.subtype == "attributes" then
         for path_name,path in pairs(skills.paths) do
            helper.log(path_name)
            if helper.in_array(player.skills.paths,path_name) then
               for skill_name,skill in pairs(path.tree) do
                  if skill_name == card.id then
                     for ability_index,ability in ipairs(skill) do
                        table.insert(abilities,ability)
                     end
                  end
               end
            end
         end
      end
   else
      for path_name,path in pairs(skills.paths) do
         if helper.in_array(player.skills.paths,path_name) then
            for skill_name,skill in pairs(path.tree) do
               local has_path = helper.in_array(player.skills.paths,skill_name)
               local has_attribute = helper.in_array(player.skills.attributes,skill_name)
               if has_path or has_attribute then
                  for ability_index,ability in pairs(skill) do
                     if not helper.in_array(player.skills.abilities,ability) then
                        local new_ability = skills.abilities[ability]
                        new_ability.index = ability
                        table.insert(abilities,new_ability)
                     end
                  end
               end
            end
         end
      end
   end
   return abilities
end


function skills.get_spells(card)
   local spells = {}
   if card then
      if card.subtype == "attributes" or card.subtype == "paths" then
         if helper.in_array(player.skills.paths,"WISDOM") then
            for skill_name,skill in pairs(skills.paths.WISDOM.spells) do
               if skill_name == card.id then
                  for spell_index,spell in ipairs(skill) do
                     table.insert(spells,spell)
                  end
               end
            end
         end
      end
   else
      if helper.in_array(player.skills.paths,"WISDOM") then
         for skill_name,skill in pairs(skills.paths.WISDOM.spells) do
            local has_path = helper.in_array(player.skills.paths,skill_name)
            local has_attribute = helper.in_array(player.skills.attributes,skill_name)
            if has_path or has_attribute then
               for spell_index,spell in pairs(skill) do
                  if not helper.in_array(player.skills.spells,spell) then
                     local new_spell = skills.spells[spell]
                     new_spell.index = spell
                     table.insert(spells,new_spell)
                  end
               end
            end
         end
      end
   end
   return spells
end

return skills