local sounds = {}

sounds.gain = .8

love.audio.setEffect('reverb_effect', {
   type = 'reverb',
   gain = sounds.gain,
   airabsorption = 0.1
})

sounds.door_open = love.audio.newSource("sounds/door_open.ogg","static")
sounds.fail = love.audio.newSource("sounds/fail.ogg","static")
sounds.sword = love.audio.newSource("sounds/sword_1.wav","static")
sounds.player_wounded = love.audio.newSource("sounds/player_wounded.mp3","static")
sounds.player_dead = love.audio.newSource("sounds/player_dead.mp3","static")
sounds.monster_wounded = love.audio.newSource("sounds/monster_wounded.wav","static")
sounds.monster_dead = love.audio.newSource("sounds/monster_dead.wav","static")
sounds.chest_open = love.audio.newSource("sounds/chest_open.ogg","static")
sounds.drink = love.audio.newSource("sounds/drink.mp3","static")
sounds.player_step_sound = love.audio.newSource("sounds/player_footstep.ogg","static") 
sounds.orb = love.audio.newSource("sounds/orb.wav","static") 
sounds.victory = love.audio.newSource("sounds/victory.mp3","static") 
sounds.teleport = love.audio.newSource("sounds/teleport.mp3","static") 
sounds.barrel_break = love.audio.newSource("sounds/crate_destroy.ogg","static")
sounds.mechanism_step = love.audio.newSource("sounds/mechanism_step.wav","static")
sounds.mechanism_end = love.audio.newSource("sounds/mechanism_end.wav","static")
sounds.trap_spike = love.audio.newSource("sounds/spiketrap.wav","static")
sounds.cast = love.audio.newSource("sounds/cast.wav","static")
sounds.magic_attack = love.audio.newSource("sounds/magic_attack.mp3","static")
sounds.game_music = love.audio.newSource("sounds/game1.ogg", "stream")
sounds.game_music:setVolume(config.music_volume)  

sounds.player_step_sound:setEffect('reverb_effect')
--sounds.set_effect(sounds.player_step_sound, 'reverb_effect')

function sounds.set_reverb(sound, gain)
   love.audio.setEffect('reverb_effect', {
      type = 'reverb',
      gain = gain,
      airabsorption = 0.1
   })
   sounds.set_effect(sound, 'reverb_effect')
end

function sounds.set_effect(sound, effect)
   sounds[sound]:setEffect(effect)
end

function sounds.play_sound(sound,position,is_sprite)
   local cell = rooms.get_cell_tiles(position)
   local gain = sounds.cell_to_gain(cell)
   if is_sprite == nil then
      sounds[sound]:setVolume(config.sound_volume)
   else
      local distance = tiles.get_distance(tiles.current_player_position,position)
      sounds[sound]:setVolume(config.sound_volume-distance/10)
   end
   love.audio.setEffect('reverb_effect', {
      type = 'reverb',
      gain = gain,
      airabsorption = 0.1
   })
   sounds.set_effect(sound, 'reverb_effect')
   sounds[sound]:play() 
end

function sounds.update_music_volume()
   sounds.game_music:setVolume(config.music_volume)
   menu.music:setVolume(config.music_volume)
end

function sounds.cell_to_gain(cell)
   if #cell<10 then
      gain = 0.5
   elseif #cell<25 then
      gain = 0.6
   elseif #cell<35 then
      gain = 0.7
   else
      gain = 0.8
   end
   return gain
end

return sounds