local transition = {}

function transition.init()
   if not transition.set then
      transition.background = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
      love.graphics.setCanvas(transition.background)  
      transition.background_alpha = 1
      love.graphics.setColor(0, 0, 0, transition.background_alpha)
      love.graphics.rectangle("fill", 1,1,love.graphics.getWidth(),love.graphics.getHeight())
      transition.fading = false
      transition.fading_step = 0.2
      transition.mode = "image"
      transition.next_function = {func=nil, args={}}
   end
   transition.draw_background()
end

function transition.fade(direction,step,mode,func,args)
   transition.fading = direction
   transition.fading_step = step
   transition.mode = mode
   transition.next_function.func = func
   transition.next_function.args = args
end

function transition.draw_background()
   love.graphics.setCanvas(transition.background)
   love.graphics.clear(0, 0, 0, 0)  
   if transition.mode == "black" then
      love.graphics.setColor(0, 0, 0, transition.background_alpha)
      love.graphics.rectangle("fill", 1,1,love.graphics.getWidth(),love.graphics.getHeight())
   elseif transition.mode == "red" then
      love.graphics.setColor(1, 0.5, 0.5, transition.background_alpha)
      love.graphics.draw( interface.image_transition , 0, 0, 0, love.graphics.getWidth()/interface.image_home:getWidth(),love.graphics.getHeight()/interface.image_home:getHeight())
   elseif transition.mode == "image" then
      love.graphics.setColor(1, 1, 1, transition.background_alpha)
      love.graphics.draw( interface.image_transition , 0, 0, 0, love.graphics.getWidth()/interface.image_home:getWidth(),love.graphics.getHeight()/interface.image_home:getHeight())
   end
   love.graphics.setCanvas()
end

return transition